/***************************************************************************
                          dx7_bank.cpp  -  description
                             -------------------
    begin                : Fri Jul 5 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dx7_bank.h"

PropertyList * Dx7_Bank::get_patch_properties(int p_patch) {

	return &patch_prop[p_patch];
}

Voice * Dx7_Bank::get_voice_internal(int p_patch) {

        Dx7_Voice *newvoice = new Dx7_Voice;

        newvoice->set_data(&patch_data[p_patch]);
	return newvoice ;
}

Dx7_Bank::Dx7_Bank() {
        int i,j,k;

	patch_data.resize(128);        	
	patch_name.resize(128);        	

	for (i=0;i<128;i++) {

		for (j=0;j<6;j++) {

			patch_prop[i].push_back(new Section_Property("Operator "+itostr(j+1)));
			patch_prop[i].push_back(new Separator_Property("Envelope Level:"));            			

			for (k=0;k<4;k++) {

				patch_prop[i].push_back(new Value_Property("Level "+itostr(k+1),0,99,&patch_data[i].operators[j].envelope.level[k]));
    			}
			patch_prop[i].push_back(new Separator_Property("Envelope Rate:"));            			
			for (k=0;k<4;k++) {

				patch_prop[i].push_back(new Value_Property("Rate "+itostr(k+1),0,99,&patch_data[i].operators[j].envelope.rate[k]));
    			}

			patch_prop[i].push_back(new Separator_Property("Tunning:"));            			
       			patch_prop[i].push_back(new Value_Property("Coarse",0,8,&patch_data[i].operators[j].coarse_tune));
       			patch_prop[i].push_back(new Value_Property("Fine",0,99,&patch_data[i].operators[j].fine_tune));
       			patch_prop[i].push_back(new Value_Property("Detune",0,7,&patch_data[i].operators[j].fine_tune));

			patch_prop[i].push_back(new Separator_Property("Volume:"));            			

       			patch_prop[i].push_back(new Value_Property("Output",0,99,&patch_data[i].operators[j].output_level));
       			patch_prop[i].push_back(new Value_Property("Key->Vol Sens.",0,99,&patch_data[i].operators[j].key_vel_sens));
          	}

		patch_prop[i].push_back(new Section_Property("Common"));

		patch_prop[i].push_back(new Value_Property("Algorithm",0,31,&patch_data[i].algorithm));
		patch_prop[i].push_back(new Value_Property("Feedback",0,7,&patch_data[i].feedback_level));

  		patch_name[i]="Patch "+itostr(i);
 	}

}

string Dx7_Bank::get_patch_name(int p_index) {

	return patch_name[p_index];
}
void Dx7_Bank::set_patch_name(int p_index,string p_name) {

	patch_name[p_index]=p_name;

}


Dx7_Bank::~Dx7_Bank(){
}
