/***************************************************************************
                          dx7_bank_load.cpp  -  description
                             -------------------
    begin                : Sat Jul 6 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dx7_bank.h"

bool Dx7_Bank::load_file(string p_file, int p_offset=0) {


	FILE *in;
	int numsamples,i;
	unsigned char aux_buf[100];

	in=fopen(p_file.c_str(),"rb");

	if (in==NULL) {

		printf("Error: Cannot open file for reading: %s\n",p_file.c_str());
		return true;
	}


	fread(aux_buf,6,1,in);

	if ( (aux_buf[0]!=0xF0) || (aux_buf[1]!=0x43) || (aux_buf[2]!=0x00) ) {

		printf("Error: Not a sysex file?!\n");
		fclose(in);
		return true;
	}

	if (aux_buf[3]==0x00) {

		numsamples=1; //1 sample


	} else if (aux_buf[3]==0x09) {

		numsamples=32; //32 samples

	} else {

		printf("Error: Cant figure out how many samples in file!\n");
		fclose(in);
		return true;
	}


	for (i=0;i<numsamples;i++) {

		int j;
		unsigned char aux_char;

                if ((i+p_offset)>=128) break;

		Dx7_Voice::Data *sdata=&patch_data[i+p_offset];

		for (j=0;j<6;j++) {


			fread(aux_buf,17,1,in);

   			sdata->operators[j].envelope.rate[0]=aux_buf[0];
   			sdata->operators[j].envelope.rate[1]=aux_buf[1];
   			sdata->operators[j].envelope.rate[2]=aux_buf[2];
   			sdata->operators[j].envelope.rate[3]=aux_buf[3];

   			sdata->operators[j].envelope.level[0]=aux_buf[4];
   			sdata->operators[j].envelope.level[1]=aux_buf[5];
   			sdata->operators[j].envelope.level[2]=aux_buf[6];
   			sdata->operators[j].envelope.level[3]=aux_buf[7];

	                sdata->operators[j].enable=true;
			sdata->operators[j].kb_scale_bkpoint=aux_buf[8];
			sdata->operators[j].kb_scaling_l_depth=aux_buf[9];
			sdata->operators[j].kb_scaling_r_depth=aux_buf[10];
			sdata->operators[j].kb_scaling_l_curve=aux_buf[11] >> 2;
			sdata->operators[j].kb_scaling_r_curve=aux_buf[11] & 3;
			
			sdata->operators[j].rate_scale=aux_buf[12] & 7;
			sdata->operators[j].detune=aux_buf[12] >> 3;
			sdata->operators[j].amp_modulation_sens=aux_buf[13] & 3;
			sdata->operators[j].key_vel_sens=aux_buf[13] >> 2;
			
			sdata->operators[j].output_level=aux_buf[14];
			sdata->operators[j].osc_mode=aux_buf[15] & 1;
			sdata->operators[j].coarse_tune=aux_buf[15] >>1;
			sdata->operators[j].fine_tune=aux_buf[16];
		}

		fread(aux_buf,26,1,in);

		sdata->pitch_envelope.rate[0]=aux_buf[0];
		sdata->pitch_envelope.rate[1]=aux_buf[1];
		sdata->pitch_envelope.rate[2]=aux_buf[2];
		sdata->pitch_envelope.rate[3]=aux_buf[3];
		
		sdata->pitch_envelope.level[0]=aux_buf[4];
		sdata->pitch_envelope.level[1]=aux_buf[5];
		sdata->pitch_envelope.level[2]=aux_buf[6];
		sdata->pitch_envelope.level[3]=aux_buf[7];
		
		sdata->algorithm=aux_buf[8];
		sdata->feedback_level=aux_buf[9]&7;
		sdata->oscilator_key_sync=aux_buf[9] >> 3;		
       		sdata->lfo.speed=aux_buf[10];
       		sdata->lfo.delay=aux_buf[11];
       		sdata->lfo.pitch_modulation_depth=aux_buf[12];
       		sdata->lfo.pitch_amplitude_depth=aux_buf[13];
       		sdata->lfo.sync=aux_buf[14]&1;;
       		sdata->lfo.wave=(aux_buf[14]>>1)&7;
       		sdata->lfo.pitch_modulation_sens=(aux_buf[14]>>1)&7;
		sdata->transpose=aux_buf[15];
		aux_buf[26]=0; //lets zero it!
  		patch_name[i]=(char*)&aux_buf[16];

	}

	fclose(in);

 	return false;
}