/***************************************************************************
                          sid_bank.cpp  -  description
                             -------------------
    begin                : Wed Jul 10 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "sid_bank.h"


PropertyList * SID_Bank::get_patch_properties(int p_patch) {

	return &patch_prop[p_patch];

}
Voice * SID_Bank::get_voice_internal(int p_patch) {
	

        SID_Voice * new_voice = new SID_Voice;

        new_voice->set_data(&patch_data[p_patch]);

	return new_voice;
}

string SID_Bank::get_patch_name(int p_index) {

	return patch_name[p_index];
}
void SID_Bank::set_patch_name(int p_index,string p_name) {

	patch_name[p_index]=p_name;

}
bool SID_Bank::load_file(string p_file, int p_offset=0) {

	return true;
}


SID_Bank::SID_Bank(){
        int i,j;
	patch_name.resize(128);
	patch_data.resize(128);


	for (i=0;i<128;i++) {

		for (j=0;j<3;j++) {

			patch_prop[i].push_back(new Section_Property("Osc. "+itostr(j+1)));
			patch_prop[i].push_back(new Separator_Property("Waveform:"));            			
			patch_prop[i].push_back(new Bool_Property("Enable: ",&patch_data[i].oscillator[j].enable));
			vector<string> waveformtype;
			waveformtype.push_back("Nothing");
			waveformtype.push_back("Triangle");
			waveformtype.push_back("Saw");
			waveformtype.push_back("Saw+Triangle");
			waveformtype.push_back("Pulse");
			waveformtype.push_back("Pulse+Triangle");
			waveformtype.push_back("Pulse+Saw");
			waveformtype.push_back("Pulse+Saw+Triangle");
			waveformtype.push_back("Noise");
			
			patch_prop[i].push_back(new Multiple_Choice_Property("Type: ",waveformtype,&patch_data[i].oscillator[j].waveform ));
			
			patch_prop[i].push_back(new Value_Property("Pulse Width (PW): ",0,0xFFF,&patch_data[i].oscillator[j].pulse_width));
			patch_prop[i].push_back(new Bool_Property("Ring Modulate: ",&patch_data[i].oscillator[j].ring_modulation));
			patch_prop[i].push_back(new Bool_Property("Sync: ",&patch_data[i].oscillator[j].sync));
			patch_prop[i].push_back(new Separator_Property("Envelope:"));            			
			patch_prop[i].push_back(new Value_Property("Attack: ",0,0xF,&patch_data[i].oscillator[j].envelope_attack));
			patch_prop[i].push_back(new Value_Property("Decay: ",0,0xF,&patch_data[i].oscillator[j].envelope_decay));
			patch_prop[i].push_back(new Value_Property("Sustain: ",0,0xF,&patch_data[i].oscillator[j].envelope_sustain));
			patch_prop[i].push_back(new Value_Property("Release: ",0,0xF,&patch_data[i].oscillator[j].envelope_release));
			patch_prop[i].push_back(new Bool_Property("Dont Sustain: ",&patch_data[i].oscillator[j].envelope_dont_sustain));
			patch_prop[i].push_back(new Separator_Property("Extra:"));            			
			patch_prop[i].push_back(new Value_Property("PW Osc. Depth: ",0,0xFF,&patch_data[i].oscillator[j].pulse_osc_depth ));
			patch_prop[i].push_back(new Value_Property("PW Osc. Speed: ",0,0xFF,&patch_data[i].oscillator[j].pulse_osc_speed ));
			patch_prop[i].push_back(new Value_Property("PW Osc. Begin: ",0,0xFF,&patch_data[i].oscillator[j].pulse_osc_begin ));
			patch_prop[i].push_back(new Separator_Property("Tunning:"));            			
			patch_prop[i].push_back(new Value_Property("Coarse Tune: ",-24,24,&patch_data[i].oscillator[j].coarse));
			patch_prop[i].push_back(new Value_Property("Fine Tune: ",-0x80,0x80,&patch_data[i].oscillator[j].fine ));


          	}

		patch_prop[i].push_back(new Section_Property("Filter"));
		
  		patch_prop[i].push_back(new Separator_Property("Properties:"));

		patch_prop[i].push_back(new Value_Property("Cutoff:",0,2048,&patch_data[i].cutoff));
		patch_prop[i].push_back(new Value_Property("Resonance:",0,0xF,&patch_data[i].resonance));
		patch_prop[i].push_back(new Bool_Property("Filtex: ",&patch_data[i].filtex));

		patch_prop[i].push_back(new Bool_Property("Filter Osc. 1: ",&patch_data[i].filter_osc_1));
		patch_prop[i].push_back(new Bool_Property("Filter Osc. 2: ",&patch_data[i].filter_osc_2));
		patch_prop[i].push_back(new Bool_Property("Filter Osc. 3: ",&patch_data[i].filter_osc_3));

  		
		patch_prop[i].push_back(new Bool_Property("Filter Voice 3 off: ",&patch_data[i].filter_voice3_off));
		patch_prop[i].push_back(new Bool_Property("Filter Highpass: ",&patch_data[i].filter_highpass));
		patch_prop[i].push_back(new Bool_Property("Filter Bandpass: ",&patch_data[i].filter_bandpass));
		patch_prop[i].push_back(new Bool_Property("Filter Lowpass: ",&patch_data[i].filter_lowpass));
		patch_prop[i].push_back(new Value_Property("Output Level: ",0,0xF,&patch_data[i].filter_vol));


  		patch_name[i]="Patch "+itostr(i+1);
 	}

}
SID_Bank::~SID_Bank(){
}
