/***************************************************************************
                          sid_voice.cpp  -  description
                             -------------------
    begin                : Wed Jul 10 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "sid_voice.h"

Voice::Status SID_Voice::get_status(){ //obvious function

	int statuscount[5] = {0,0,0,0,0};


 	for (int i=0;i<3;i++) {

		statuscount[sid.v[i].adsrm]++;
  	}
   	if (statuscount[4]==3) {

    		return Voice::DEAD;
    	} else {

    		return Voice::RELEASING;
	} 	    	

}	
void SID_Voice::poll_for_dead_staus(){ //call in case we try to figure out if this note voice is dead

}
void SID_Voice::set_note_internal(char p_note,char p_velocity) {

	int i,j;

	update_pitch_stuff();
	
	for (i = 0, j = 0; i < 3; i++, j += 7) {
		Data::Oscillator& osc = used_data.oscillator[i];
		if (osc.envelope_dont_sustain)
			fastsid_avoid_sustain(&sid,i);
	}

}

void SID_Voice::set_note_off_internal(char p_velocity){

        int i,j;
	for (i = 0, j = 0; i < 3; i++, j += 7) {
		Data::Oscillator& osc = used_data.oscillator[i];
		fastsid_store(&sid,j + 4 , (osc.waveform << 4) | (osc.test ? 0x08 : 0) | (osc.ring_modulation ? 0x04 : 0) | (osc.sync ? 0x02 : 0) | (0));
	}
}


void SID_Voice::update_pitch_stuff() {

        int i,j;

	for (i = 0, j = 0; i < 3; i++, j += 7) {
		Data::Oscillator& osc = used_data.oscillator[i];

	        float cnote=osc.coarse; //note+coarse

         	cnote+=(float)osc.fine/128; //note+fine


          	cnote+=get_fnote();

	        int sidfreq;
	        cnote=8.1757989156*pow(2.0,cnote/12.0); //get freq
	        cnote=cnote/0.06097; // and now get sid freq
                if (cnote<0) cnote=0;
         	if (cnote>0xFFFF) cnote=0xFFFF; 		
	        sidfreq=cnote;

//		fastsid_store(&sid,j + 0 ,  wave.freq & 0xff);
//		fastsid_store(&sid,j + 1 ,  wave.freq >> 8);
		fastsid_store(&sid,j + 0 ,  sidfreq&0xFF);
		fastsid_store(&sid,j + 1 ,  (sidfreq>>8)&0xFF);
	}

}

void SID_Voice::set_data(Data *p_data) {

	int i,j;

//	sid.set_chip_model(MOS6581);
//        sid.reset();


	for (i = 0, j = 0; i < 3; i++, j += 7) {

		used_data=*p_data;         		

		Data::Oscillator& osc = p_data->oscillator[i];
  		
//		fastsid_store(&sid,j + 0 ,  wave.freq & 0xff);
//		fastsid_store(&sid,j + 1 ,  wave.freq >> 8);
//		fastsid_store(&sid,j + 0 ,  0x44);
//		fastsid_store(&sid,j + 1 ,  0x44);
		fastsid_store(&sid,j + 2 ,  osc.pulse_width & 0xff);
		fastsid_store(&sid,j + 3 ,  osc.pulse_width >> 8);
		fastsid_store(&sid,j + 4 , (osc.waveform << 4) | (osc.test ? 0x08 : 0) | (osc.ring_modulation ? 0x04 : 0) | (osc.sync ? 0x02 : 0) | (osc.enable ? 0x01 : 0));
		fastsid_store(&sid,j + 5 , (osc.envelope_attack << 4) | osc.envelope_sustain);
		fastsid_store(&sid,j + 6 , (osc.envelope_decay << 4)  | osc.envelope_release);
	}

	fastsid_store(&sid,j++ ,  p_data->cutoff & 0x007);
	fastsid_store(&sid,j++ ,  p_data->cutoff >> 3);
	fastsid_store(&sid,j++ ,	(p_data->resonance << 4) |
 			(p_data->filtex ? 0x08 : 0) |
    			((p_data->filter_osc_3?1:0) << 2 ) |
    			((p_data->filter_osc_2?1:0) << 1 ) |
    			((p_data->filter_osc_1?1:0)  ) );

	fastsid_store(&sid,j++ , (p_data->filter_voice3_off ? 0x80 : 0)
			| ((p_data->filter_highpass?1:0) << 6)
			| ((p_data->filter_bandpass?1:0) << 5)
			| ((p_data->filter_lowpass? 1:0) << 4)
			| (p_data->filter_vol) );

}

void SID_Voice::mix_modifier_call() {

	update_extra_effects();	

}

void SID_Voice::update_extra_effects() {
        int i,j;

	for (i = 0, j = 0; i < 3; i++, j += 7) {
		
  		Data::Oscillator& osc = used_data.oscillator[i];

         	int pw=osc.pulse_width+16*osc.pulse_osc_depth*sin( ( (float)((get_update_count()+osc.pulse_osc_begin) % 0x100)*(M_PI*2)/(float)0x100)*((float)(osc.pulse_osc_speed+1)/10.0) );
          	if (pw<0) pw=0;
          	if (pw>4095) pw=4095;

		fastsid_store(&sid,j + 2 ,  pw & 0xff);                         
		fastsid_store(&sid,j + 3 ,  pw >> 8);
 	}        	

}

void SID_Voice::recalculate_pitch_internal() {

	update_pitch_stuff();
}


void SID_Voice::set_mix_frequency_internal(int p_mixfreq){

        fastsid_init(&sid,p_mixfreq,985248);
}

void SID_Voice::mix_internal(int p_amount,Sint32* p_where){



        int clock_delta=5000; //enough?

        int mix_volume_left;
        int mix_volume_right;
        int mix_volume;

        mix_volume=get_total_volume()*(1<<15); // 15 bits
	 	
	mix_volume_right=get_total_pan()*mix_volume >> 7;
	mix_volume_left=(127-get_total_pan())*mix_volume >> 7;

        int hehe=fastsid_calculate_samples(&sid,buffer,p_amount,1,&clock_delta);
        Sint16 *src=buffer;
        
   	while (p_amount--) { 

    	//printf("hey %i\n",*src);
      	//*src+=16384;

    		*p_where += *src * mix_volume_left;

  		*p_where++;

    		*p_where += *src * mix_volume_right;

  		*p_where++;

    		src++;
       	}

   	
}

SID_Voice::SID_Voice(){

        memset(&sid,0,sizeof(sound_t));

}
SID_Voice::~SID_Voice(){
}
