/***************************************************************************
                          sid_voice.h  -  description
                             -------------------
    begin                : Wed Jul 10 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SID_VOICE_H
#define SID_VOICE_H

#include "voice.h"
#include "fastsid.h"
//#include "sid.h"

/**
  *@author red
  */

class SID_Voice : public Voice  {
public:

	struct Data {

		struct Oscillator {

			int pulse_width; // 0 - 0xFFFF
   			int waveform; // 0 - 0xF
      			bool test; // ?
         		bool ring_modulation;
           		bool sync;
             		bool enable;
             		//bool envelope_gate;
                        /////
                        int envelope_attack; // 0 - 0xF
                        int envelope_decay; // 0 - 0xF
                        int envelope_sustain; // 0 - 0xF
                        int envelope_release; // 0 - 0xF
             		bool envelope_dont_sustain;

                        /* EXTRA (not in chip, but effects usually done with programming) */

                        int pulse_osc_depth; // 0 - 0xFF
                        int pulse_osc_speed; // 0 - 0xFF
                        int pulse_osc_begin; // 0 - 0xFF
                                 		
                        int coarse; // -24 /+ 24
                        int fine; // -0x80 /+ 0x80

  		} oscillator[3];
	
		int cutoff; // 0 - 0x3F
                int resonance; // 0 - 0xF
                bool filtex;
                bool filter_osc_1;
                bool filter_osc_2;
                bool filter_osc_3;
                bool filter_voice3_off;
                bool filter_highpass;
                bool filter_bandpass;
                bool filter_lowpass;
                int filter_vol; //0 - 0xF


		Data() {

			memset(this,0,sizeof(Data));
         		oscillator[0].enable=true;
         		oscillator[0].waveform=1;
         		oscillator[0].envelope_attack=0x8;
           		oscillator[0].envelope_decay=0x8;
           		oscillator[0].envelope_sustain=0x8;
             		oscillator[0].envelope_release=0x8;
               		filter_vol=0xF;
     		
  		}
	};
        sound_t sid;
        void update_extra_effects();
private:
 	int effect_update_interval_time; // update interfal for effects (times per second)

	int base_freq;

// 	SID sid; //'nuff said
//        cycle_count clock_delta;
        Sint16 buffer[16384];


	Data used_data;

        void update_pitch_stuff();
	void recalculate_pitch_internal();        
public:

	void set_data(Data *p_data);


	Status get_status(); //obvious function
	
	void poll_for_dead_staus(); //call in case we try to figure out if this note voice is dead

        void set_note_internal(char p_note,char p_velocity); //noteon
	void set_note_off_internal(char p_velocity); //noteoff
	void mix_modifier_call();

public: /* MIXING! */

	void set_mix_frequency_internal(int p_mixfreq); //set mixing freq
	void mix_internal(int p_amount,Sint32* p_where); //set where to mix

	SID_Voice();
	~SID_Voice();
};

#endif
