/***************************************************************************
                          sine_bank.cpp  -  description
                             -------------------
    begin                : Wed Jul 10 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "sine_bank.h"


PropertyList * SINE_Bank::get_patch_properties(int p_patch) { //returns a "property list", which tells legasynth how to configure this voice

	return &patch_prop[p_patch]; //this stuff is internal for Bank, I'll end up replacing it with a function probably
	

}
Voice * SINE_Bank::get_voice_internal(int p_patch) {


        SINE_Voice * new_voice = new SINE_Voice; //we create the voice

        new_voice->set_data(&patch_data[p_patch]);  ///but before giving it back, we'll configure it with the patch preset

	return new_voice; //and there it goes
}

string SINE_Bank::get_patch_name(int p_index) {

	return patch_name[p_index]; //get a patch name
}
void SINE_Bank::set_patch_name(int p_index,string p_name) {

	patch_name[p_index]=p_name; //set a patch name.. nothing amazing

}


SINE_Bank::SINE_Bank(){
        int i,j;
        
	patch_name.resize(128); //we know we'll have 128 names
	patch_data.resize(128); //and 128 patches.. it's not a magic number, it's MIDI!, i could replace it with a MIDI_HAS_ONLY_7_BITS_FOR_EVERYTHING_BECAUSE_IT_SUCKS macro, but i'll better not.


	for (i=0;i<128;i++) {


		patch_prop[i].push_back(new Section_Property("Stuff")); //create a section called, "Stuff", dont worry, the propertylist will later delete it

  		patch_prop[i].push_back(new Separator_Property("Play?:")); //create a separator called "Play?"

		patch_prop[i].push_back(new Bool_Property("Envelope: ",&patch_data[i].play)); ///link to a "bool" type variable

		patch_prop[i].push_back(new Value_Property("Decay:",0,10,&patch_data[i].decay)); //coarse tunning, be sure to allways supply an "int" as parameter for this and nothing else
		
  		patch_prop[i].push_back(new Separator_Property("Tunning:")); //create a separator called "Play?"
        
		patch_prop[i].push_back(new Value_Property("Coarse:",-12,12,&patch_data[i].coarse)); //coarse tunning, be sure to allways supply an "int" as parameter for this and nothing else

				
  		patch_name[i]="Evil Sine #"+itostr(i+1); //patch name
 	}

}
SINE_Bank::~SINE_Bank(){
}
