/***************************************************************************
                          sid_bank.cpp  -  description
                             -------------------
    begin                : Wed Jul 10 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ym2x_bank.h"
#include "algo0.xpm"
#include "algo1.xpm"
#include "algo2.xpm"
#include "algo3.xpm"
#include "algo4.xpm"
#include "algo5.xpm"
#include "algo6.xpm"
#include "algo7.xpm"


PropertyList * OPN_Bank::get_patch_properties(int p_patch) {

	return &patch_prop[p_patch];

}
Voice * OPN_Bank::get_voice_internal(int p_patch) {


        OPN_Voice * new_voice = new OPN_Voice;

        new_voice->set_data(&patch_data[p_patch]);

	return new_voice;
}

string OPN_Bank::get_patch_name(int p_index) {

	return patch_name[p_index];
}
void OPN_Bank::set_patch_name(int p_index,string p_name) {

	patch_name[p_index]=p_name;

}
bool OPN_Bank::load_file(string p_file, int p_offset=0) {

	return true;
}


OPN_Bank::OPN_Bank(){
        int i,j;
	patch_name.resize(128);
	patch_data.resize(128);

//			patch_prop[i].push_back(new Bool_Property("Enable: ",&patch_data[i].oscillator[j].enable));

	for (i=0;i<128;i++) {

		OPN_Voice::Data *p_data=&patch_data[i];
		
		for (j=0;j<4;j++) {
		
			OPN_Voice::Data::Operator &op=p_data->op[j];
			
			patch_prop[i].push_back(new Section_Property("Op. "+itostr(j+1)));
			patch_prop[i].push_back(new Separator_Property("Envelope:"));
			patch_prop[i].push_back(new Value_Property("Attack: ",0,0x1f,&op.attack ));
			patch_prop[i].push_back(new Value_Property("Decay: ",0,0x1f,&op.decay ));
			patch_prop[i].push_back(new Value_Property("Sustain: ",0,0x1f,&op.sustain ));
			patch_prop[i].push_back(new Value_Property("Sust. Level: ",0,0xf,&op.sustain_level ));
			patch_prop[i].push_back(new Value_Property("Release: ",0,0xf,&op.release ));		
			patch_prop[i].push_back(new Value_Property("Output Level: ",0,0x7f,&op.total_level ));
			patch_prop[i].push_back(new Value_Property("Key scale Rate: ",0,0x7,&op.key_scale_rate ));
			patch_prop[i].push_back(new Separator_Property("Tunning:"));
			
			patch_prop[i].push_back(new Value_Property("Coarse: ",0,0xf,&op.coarse ));
			patch_prop[i].push_back(new Value_Property("Fine: ",0,0xf,&op.fine ));
			
		}

		patch_prop[i].push_back(new Section_Property("Global"));
		patch_prop[i].push_back(new Separator_Property("Misc:"));

		vector<char*> xpmlist;
		xpmlist.push_back((char*)algo0_xpm);		
		xpmlist.push_back((char*)algo1_xpm);
		xpmlist.push_back((char*)algo2_xpm);
		xpmlist.push_back((char*)algo3_xpm);
		xpmlist.push_back((char*)algo4_xpm);
		xpmlist.push_back((char*)algo5_xpm);
		xpmlist.push_back((char*)algo6_xpm);
		xpmlist.push_back((char*)algo7_xpm);
		patch_prop[i].push_back(new Image_Choice_Property("Algorithm: ",xpmlist,&p_data->algorithm ));
		patch_prop[i].push_back(new Value_Property("Feedback: ",0,0x7,&p_data->feedback ));
		
		patch_prop[i].push_back(new Value_Property("Amp. Mod. Sens.: ",0,0x7,&p_data->amp_modulation_sens));
		patch_prop[i].push_back(new Value_Property("Pitch Mod. Sens.: ",0,0x7,&p_data->pitch_modulation_sens));

  		patch_name[i]="Patch "+itostr(i+1);
 	}

}

bool OPN_Bank::load_patch(string p_file, int p_index) {

	char str[5];
	FILE *f;
	str[4]=0;

	f=fopen(p_file.c_str(),"rb");
	if (f==NULL) return false;

	fread(str,1,4,f);

        if ((string)str!="2XXX") {
		fclose(f);
		return false;
        }
	
        fread(&patch_data[p_index],1,sizeof(OPN_Voice::Data),f);
	
	fclose(f);
	return true;
}

OPN_Bank::~OPN_Bank(){
}
