/***************************************************************************
                          OPN_voice.cpp  -  description
                             -------------------
    begin                : Wed Jul 10 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ym2x_voice.h"
#include <math.h>

Voice::Status OPN_Voice::get_status(){ //obvious function

   	if (OPN_PollDead(&opn)) {

    		return Voice::DEAD;
    	} else {

    		return Voice::RELEASING;
	}

}
void OPN_Voice::poll_for_dead_staus(){ //call in case we try to figure out if this note voice is dead

}
void OPN_Voice::set_note_internal(char p_note,char p_velocity) {

	update_pitch_stuff();
	OPNWriteMode(&opn,0x28,0x10|0x20|0x40|0x80);


}

void OPN_Voice::set_note_off_internal(char p_velocity){

        int i,j;
	OPNWriteMode(&opn,0x28,0);
        
}

void OPN_Voice::update_pitch_stuff() {

        int i,j;

        //must get the freq back! DAMN!
        double cnote=get_fnote();
        int octave,freq,final_note;

        cnote-=24; //less stuff!
	cnote/=12; //sucks

	octave=(double)cnote; //easy;
	cnote=cnote-(float)octave; //no more integer part
	
	if (octave<0) {

		cnote=cnote+(float)octave; //will have to go out of range!
		octave=0;

	}

	if (octave>7) {

		cnote=cnote+(float)octave; //will have to go out of range!
		octave=7;
	}

	freq=653*pow(2,cnote); //653 is C?

//	freq=(int)(cnote*(float)(1<<11)); // 11 bits for frequency..

	if (freq<0) freq=0; //lower limit hit
	if (freq>2047) freq=2047; //higher limit hit
      

	final_note=(octave<<11) | freq;	

      
        
	OPNWriteReg(&opn, 0xA4 ,final_note>>8); //octave
	OPNWriteReg(&opn, 0xA0 ,final_note&0xFF); //finetune
}

void OPN_Voice::recalculate_pitch_internal() {

	update_pitch_stuff();
}


void OPN_Voice::set_data(Data *p_data) {

	int i,j;

	used_data=*p_data;
}


void OPN_Voice::update_extra_effects() {
/*
        int i,j;
	for (i = 0, j = 0; i < 3; i++, j += 7) {

  		Data::Oscillator& osc = used_data.oscillator[i];

         	int pw=osc.pulse_width+16*osc.pulse_osc_depth*sin( ( (float)((effect_count+osc.pulse_osc_begin) % 0x100)*(M_PI*2)/(float)0x100)*(osc.pulse_osc_speed+1) );

		fastOPN_store(&OPN,j + 2 ,  pw & 0xff);
		fastOPN_store(&OPN,j + 3 ,  pw >> 8);
 	}
  */
}



void OPN_Voice::set_mix_frequency_internal(int p_mixfreq){

        OPN_Init(&opn,7520000L,p_mixfreq,NULL,NULL);

	#define BUILDREG(m_command,m_slot) (((m_command)<<4)|((m_slot)<<2))

	for (int i=0;i<4;i++) {

		Data::Operator &op=used_data.op[3-i];
		OPNWriteReg(&opn, BUILDREG(3,i) ,op.coarse|(op.fine<<4));
		OPNWriteReg(&opn, BUILDREG(4,i) ,0x7F-op.total_level);
		OPNWriteReg(&opn, BUILDREG(5,i) ,((op.key_scale_rate)<<5)|(0x1F-op.attack));
		OPNWriteReg(&opn, BUILDREG(6,i) ,(0x1F-op.decay));
		OPNWriteReg(&opn, BUILDREG(7,i) ,(0x1F-op.sustain));
		OPNWriteReg(&opn, BUILDREG(8,i) ,(0xF-op.release)|((0xF-op.sustain_level)<<4));
//		OPNWriteReg(&opn, BUILDREG(8,i) ,(op.release)|(op.sustain_level<<4));

	}

	OPNWriteReg(&opn, BUILDREG(0xB,0) ,(used_data.feedback<<3)|used_data.algorithm);
	OPNWriteReg(&opn, BUILDREG(0xB,1) ,(used_data.pitch_modulation_sens<<4)|used_data.pitch_modulation_sens);
        
}

void OPN_Voice::mix_internal(int p_amount,Sint32* p_where) {



        int clock_delta=5000; //enough?

        int mix_volume_left;
        int mix_volume_right;
        int mix_volume;

        mix_volume=get_total_volume()*(1<<15); // 15 bits

	mix_volume_right=get_total_pan()*mix_volume >> 7;
	mix_volume_left=(127-get_total_pan())*mix_volume >> 7;

        int *src=buffer;

 	
        OPN_Update(&opn,buffer,p_amount);
        while (p_amount--) {

      		*src>>=13;

  		*p_where += *src * mix_volume_left;

		*p_where++;

  		*p_where += *src * mix_volume_right;

		*p_where++;

  		src++;
	}


}

OPN_Voice::OPN_Voice(){

        memset(&opn,0,sizeof(FM_OPN));
}
OPN_Voice::~OPN_Voice(){
}
