/***************************************************************************
                          sid_voice.h  -  description
                             -------------------
    begin                : Wed Jul 10 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef OPN_VOICE_H
#define OPN_VOICE_H

#include "voice.h"
#include "fm.h"
//#include "sid.h"

/**
  *@author red
  */

class OPN_Voice : public Voice  {
public:

	struct Data {

		struct Operator {

			int attack; //0 - 0x1F
			int decay; //0 - 0x1F
			int sustain; //0 - 0x1F
			int release; //0 - 0xF
			int sustain_level; //0 - 0xF
			
			int key_scale_rate; //0-7
			int coarse; //0-0xF
			int fine; //0-0xF		
			int total_level; //0-0x7F
		} op[4];


		int algorithm; // 0 - 7
		int feedback; // 0 - 7
		int amp_modulation_sens; // 0 - 0xF
		int pitch_modulation_sens; // 0 - 7

		
		Data() {

			memset(this,0,sizeof(Data));
			op[0].attack=5;
			op[0].decay=5;
			op[0].sustain=5;
			op[0].release=5;
			op[0].sustain_level=5;
			op[0].total_level=0x7f;
  			op[0].coarse=1;

  		}
	};

	
        FM_OPN opn;
        void update_extra_effects();
        void update_pitch_stuff();
private:

	int base_freq;

// 	OPN sid; //'nuff said
//        cycle_count clock_delta;
        int buffer[16384];


	Data used_data;


public:
        void recalculate_pitch_internal();
	void set_data(Data *p_data);


	Status get_status(); //obvious function

	void poll_for_dead_staus(); //call in case we try to figure out if this note voice is dead

        void set_note_internal(char p_note,char p_velocity); //noteon
	void set_note_off_internal(char p_velocity); //noteoff

public: /* MIXING! */

	void set_mix_frequency_internal(int p_mixfreq); //set mixing freq
	void mix_internal(int p_amount,Sint32* p_where); //set where to mix

	OPN_Voice();
	~OPN_Voice();
};

#endif
