
#include "file_browser.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include <stdio.h>

void FileBrowser::regenerate_listing() {

	char real_current_dir_name[500];
        typedef struct stat Stat;
	DIR *dir_stream;
	dirent *entry;
	Stat flags;

	getcwd(real_current_dir_name,500);
	chdir(current_dir.c_str());
	dir_stream = opendir(current_dir.c_str());
				
	file_list.clear();
	dir_list.clear(); //TODO -- add C:/D:/E:/etc for DOS!
	
	while (dir_stream!=NULL) {
	
		string aux_name;
		entry=readdir(dir_stream);
		if (entry==NULL) break;
		if (stat(entry->d_name,&flags)) continue;
		aux_name=entry->d_name;

		if (S_ISDIR(flags.st_mode)) {
			
			dir_list.push_back(aux_name);
						
		} else if (S_ISREG(flags.st_mode)) {
		
			file_list.push_back(aux_name);
		} else {

          		printf("skipped %i\n",aux_name.c_str());
          	}
	}
	
	closedir(dir_stream);
	chdir(real_current_dir_name);	
		
	dir_list.sort();	
	file_list.sort();
}

list<string>::const_iterator FileBrowser::get_file_list() {

	return file_list.begin();
}
list<string>::const_iterator FileBrowser::get_file_list_end() {

	return file_list.end();

}

list<string>::const_iterator FileBrowser::get_dir_list() {

	return dir_list.begin();

}

list<string>::const_iterator FileBrowser::get_dir_list_end() {

	return dir_list.end();

}

		
void FileBrowser::change_dir(string p_dir) {


	char fake_current_dir_name[500];
	char real_current_dir_name[500];
	string old_dir;
	old_dir=current_dir;
	if (p_dir.length()==0) return;

	//TODO - detect dos C:/D:/E:/F:/etc
	
	if (p_dir.substr(0,1)==DIR_SEPARATOR) {
	
		current_dir=p_dir;
	} else {
	
		current_dir+=DIR_SEPARATOR+p_dir;
	}

	getcwd(real_current_dir_name,500);
	
	if (chdir(current_dir.c_str())){ //invalid directory!! (YARR!!)
	
	 	current_dir=old_dir;
	 	return; //no luck!
	}

	getcwd(fake_current_dir_name,500);

	chdir(real_current_dir_name);	
	current_dir=fake_current_dir_name;

	
	regenerate_listing();
}

string FileBrowser::get_dir() {

	return current_dir;
}

void FileBrowser::create_dir(string cd) {

		
}
	
void FileBrowser::is_file(string p_fname) {


}

void FileBrowser::is_dir(string p_fname) {


}

void FileBrowser::exists(string p_fname) {


}
	
	
void FileBrowser::set_extension_filter(string p_extension) {


}



FileBrowser::FileBrowser(){


current_dir=".";

}
FileBrowser::~FileBrowser(){


}
