/***************************************************************************
                          file_select_widget.cpp  -  description
                             -------------------
    begin                : Mon Jun 17 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "file_select_widget.h"
#include <stdio.h>
#include "popups.h"

#ifndef WIN32_ENABLED

FileSelectWidget::FileSelectWidget() : Gtk::Window(GTK_WINDOW_TOPLEVEL) {
        current_rule=-1;
	button_parent = new Gtk::Button("Parent");
	entry_directory = new Gtk::Entry();
	button_makedir = new Gtk::Button("Make dir");
	hbox1 = new Gtk::HBox(false, 0);
	action_area= new Gtk::HBox(false, 0);
	clist_directories = new Gtk::CList(1);
	scrolledwindow1 = new Gtk::ScrolledWindow();
	vseparator1 = new Gtk::VSeparator();
	clist_files = new Gtk::CList(1);
	scrolledwindow2 = new Gtk::ScrolledWindow();
	hbox2 = new Gtk::HBox(false, 0);
	label3 = new Gtk::Label("File:");
	label4 = new Gtk::Label("Filter:");
	entry_file = new Gtk::Entry();
	button3 = new Gtk::Button("Ok");
	button4 = new Gtk::Button("Cancel");
	optionmenu_filter = new Gtk::OptionMenu();
	table1 = new Gtk::Table(2, 3, false);
	vbox1 = new Gtk::VBox(false, 6);

	hbox1->pack_start(*button_parent, false, false, 0);
	hbox1->pack_start(*entry_directory);
	hbox1->pack_start(*button_makedir, false, false, 0);
	clist_directories->set_column_title(0, "Directories");
	clist_directories->set_column_justification(0, GTK_JUSTIFY_CENTER);
	clist_directories->set_column_width(0, 80);
	clist_directories->column_titles_show();
	scrolledwindow1->set_policy(GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	scrolledwindow1->add(*clist_directories);
	vseparator1->set_usize(9, -1);
	clist_files->set_column_title(0, "Files");
	clist_files->set_column_justification(0, GTK_JUSTIFY_CENTER);
	clist_files->set_column_width(0, 80);
	clist_files->column_titles_show();
	scrolledwindow2->set_policy(GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	scrolledwindow2->add(*clist_files);
	hbox2->pack_start(*scrolledwindow1);
	hbox2->pack_start(*vseparator1, false, true, 0);
	hbox2->pack_start(*scrolledwindow2);
	label3->set_alignment(0, 0.5);
	label3->set_padding(0, 0);
	label4->set_alignment(0, 0.5);
	label4->set_padding(0, 0);
	entry_file->set_editable(true);
	{
	
		_m = (new Gtk::Menu());
		Gtk::MenuItem *_mi;
		_m->set_active(0);
		optionmenu_filter->set_menu(*_m);
	}
	table1->attach(*label3, 0, 1, 0, 1, GTK_FILL, 0, 0, 0);
	table1->attach(*label4, 0, 1, 1, 2, GTK_FILL, 0, 0, 0);
	table1->attach(*entry_file, 1, 2, 0, 1, GTK_EXPAND|GTK_FILL, 0, 0, 0);
	table1->attach(*button3, 2, 3, 0, 1, GTK_FILL, 0, 0, 0);
	table1->attach(*button4, 2, 3, 1, 2, GTK_FILL, 0, 0, 0);
	table1->attach(*optionmenu_filter, 1, 2, 1, 2, GTK_FILL, GTK_FILL, 0, 0);
	vbox1->set_border_width(6);
	vbox1->pack_start(*hbox1, false, true, 0);
	vbox1->pack_start(*hbox2);
	vbox1->pack_start(*action_area,false,false,0);
	vbox1->pack_start(*table1, false, true, 0);
	set_title("File Select");
	add(*vbox1);
	button_parent->show();
	entry_directory->show();
	button_makedir->show();
	hbox1->show();
	clist_directories->show();
	scrolledwindow1->show();
	vseparator1->show();
	clist_files->show();
	scrolledwindow2->show();
	hbox2->show();
 	action_area->show();
	label3->show();
	label4->show();
	entry_file->show();
	button3->show();
	button4->show();
	optionmenu_filter->show();
	table1->show();
	vbox1->show();

	button_parent->clicked.connect(SigC::slot((this), &FileSelectWidget::on_button_parent_clicked));
	button_makedir->clicked.connect(SigC::slot((this), &FileSelectWidget::on_button_makedir_clicked));
	clist_directories->select_row.connect(SigC::slot((this), &FileSelectWidget::on_clist_directories_select_row));
	clist_files->select_row.connect(SigC::slot((this), &FileSelectWidget::on_clist_files_select_row));
	button3->clicked.connect(SigC::slot((this), &FileSelectWidget::on_button3_clicked));
	button4->clicked.connect(SigC::slot((this), &FileSelectWidget::on_button4_clicked));
	
	action=WAITING;
 	mode=LOAD;		
	clist_directories->set_column_justification(0,GTK_JUSTIFY_LEFT);
	clist_files->set_column_justification(0,GTK_JUSTIFY_LEFT);

  	browser.change_dir(".");
   	update_files();
	set_usize(400,400);
       	set_position(GTK_WIN_POS_CENTER);

        FilterRule new_rule;

        new_rule.description="All files";
        new_rule.rules.push_back("");
        add_filter_rule(new_rule);

	show();
}


void FileSelectWidget::update_files() {

	list<string>::const_iterator I;
	
	clist_directories->clear();
	clist_files->clear();
	
	clist_files->freeze();
 	clist_directories->freeze();

	for(I=browser.get_file_list();I!=browser.get_file_list_end();I++) {

               	bool allequal=true;
                list<string> gtksucks;
		//gchar *pepe[1]={"kakaz"}
                if (!match_with_current_rule(*I)) continue;
    		gtksucks.push_back(*I);
  		clist_files->append(gtksucks);		
	}
	for(I=browser.get_dir_list();I!=browser.get_dir_list_end();I++) {
	
                list<string> gtksucks;
    		gtksucks.push_back(*I);
  		clist_directories->append(gtksucks);		
	}
	
	entry_directory->set_text(browser.get_dir());
	clist_files->thaw();
 	clist_directories->thaw();
	
}

void FileSelectWidget::poll_until_action(Gtk::Main &p_kit) {

        action=WAITING;
        kit=&p_kit;
	do {

		while (kit->events_pending()) kit->iteration();
		usleep(1);

	} while (action==WAITING);

}

void FileSelectWidget::on_button_parent_clicked() {
          	
	browser.change_dir("..");
	update_files();
	entry_file->set_text("");
}

void FileSelectWidget::on_button_makedir_clicked()
{
}

void FileSelectWidget::on_clist_directories_select_row(gint row, gint column, GdkEvent *event) {
        if (event==NULL) return;

	if (event->type==GDK_2BUTTON_PRESS) {

 		string dir;
         	dir=clist_directories->cell(row,0).get_text();
          	browser.change_dir(dir);
           	update_files();
                entry_file->set_text("");
	}
}

void FileSelectWidget::on_clist_files_select_row(gint row, gint column, GdkEvent *event) {

        if (event==NULL) return;
        entry_file->set_text(clist_files->cell(row,0).get_text());

	if (event->type==GDK_2BUTTON_PRESS) { //file was selected!

        	button_action_pressed();
	}

}

string FileSelectWidget::get_filename() {

	string fname=entry_directory->get_text()+DIR_SEPARATOR+entry_file->get_text();
 	if (fname=="//") fname="/";
	return fname;
}

void FileSelectWidget::button_action_pressed() {

	string tmp_filename;
	
        tmp_filename=get_filename();

	if (tmp_filename[tmp_filename.length()-1]=='/') {

		/* might as well change directory */

		return;
	}
	
	if (mode==LOAD) {

		action=OK;

	} else if (mode==LOAD_MANY) {

                if (clist_files->selection().size()>0)  {

                	action=OK;
                }

 	} else {

                FILE *t_f;
                Dialog_OkCancel *confirm_overwrite;
		t_f=fopen(tmp_filename.c_str(),"r");
		if (t_f!=NULL) {

			confirm_overwrite=new Dialog_OkCancel("File exists! overwrite?",*kit);
			if (confirm_overwrite->get_action()==Dialog_OkCancel::OK) action=OK;
			delete confirm_overwrite;
			fclose(t_f);
		} else {
		
                	action=OK;
		}
	}
}

list<string> FileSelectWidget::get_list_of_filenames() {


	list<string> listofnames;

 	for (int i=0;i<clist_files->selection().size();i++) {
                string newrow=entry_directory->get_text()+DIR_SEPARATOR;
                if (newrow=="//") newrow="/";
           	newrow+=clist_files->selection()[i][0].get_text();

          	listofnames.push_back(newrow);
  	}

   	return listofnames;
}



bool FileSelectWidget::match_with_current_rule(string p_what) {

	if (current_rule==-1) return false;

 	bool pass=false;

  	for (int i=0;i<filter_rules[current_rule].rules.size();i++) {

		if (filter_rules[current_rule].rules[i].length()>p_what.length()) continue;

  		if (filter_rules[current_rule].rules[i]=="") pass=true; //haky but works perfects

    		bool allequal=true;

  		for (int j=1;j<=filter_rules[current_rule].rules[i].length();j++) {

            		int left=(toupper(p_what[p_what.length()-j]));
              		int right=(toupper(filter_rules[current_rule].rules[i][filter_rules[current_rule].rules[i].length()-j]));

			if (left!=right)
           			allequal=false;

            	}


             	if (allequal) pass=true;
  	}
   	return pass;
}

void FileSelectWidget::on_button3_clicked() {


        button_action_pressed();

}

void FileSelectWidget::on_button4_clicked() {

	action=CANCEL;

}

void FileSelectWidget::set_mode(Mode p_mode) {

	mode = p_mode;

	clist_files->set_selection_mode( (mode==LOAD_MANY) ?  GTK_SELECTION_EXTENDED :  GTK_SELECTION_SINGLE);

}

void FileSelectWidget::add_filter_rule(FileSelectWidget::FilterRule &filter_rule) {

        string text;
        Gtk::MenuItem *new_item;

        text+=filter_rule.description+": (";
        for (int i=0;i<filter_rule.rules.size();i++) {

                if (i!=0) {
                	text+=", ";

        	}

         	text+="*"+filter_rule.rules[i];
        }
        text+=")";

        new_item = new Gtk::MenuItem(text);


	_m->append(*new_item);
 	new_item->show();

	_m->select_item(*new_item);
	_m->activate_item(*new_item,true);        	

  	new_item->activate.connect(SigC::bind<int>(SigC::slot(this,&FileSelectWidget::select_filter),filter_rules.size()));

        filter_rules.push_back(filter_rule);

        select_filter(filter_rules.size()-1);

}


void FileSelectWidget::select_filter(int p_which) {


	current_rule=p_which;
        update_files();

}

FileSelectWidget::Action FileSelectWidget::get_action() {

	return action;
}

Gtk::HBox *FileSelectWidget::get_action_area() {

	return action_area;
}

FileSelectWidget::~FileSelectWidget(){

	delete	button_parent;
	delete	entry_directory;
	delete	button_makedir;
	delete	hbox1;
	delete	clist_directories;
	delete	scrolledwindow1;
	delete	vseparator1;
	delete	clist_files;
	delete	scrolledwindow2;
	delete	hbox2;
	delete	label3;
	delete	label4;
	delete	entry_file;
	delete	button3;
	delete	button4;
	delete	optionmenu_filter;
	delete	table1;
	delete	vbox1;
	delete	action_area;
 	delete _m;

  	for (int i=0;i<extension_item.size();i++) {

           	delete extension_item[i];
   	}



}

#endif