/***************************************************************************
                          file_select_widget.h  -  description
                             -------------------
    begin                : Mon Jun 17 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FILE_SELECT_WIDGET_H
#define FILE_SELECT_WIDGET_H

#include <gtk--/button.h>
#include <gtk--/entry.h>
#include <gtk--/box.h>
#include <gtk--/label.h>
#include <gtk--/clist.h>
#include <gtk--/scrolledwindow.h>
#include <gtk--/separator.h>
#include <gtk--/menu.h>
#include <gtk--/menuitem.h>
#include <gtk--/optionmenu.h>
#include <gtk--/table.h>
#include <gtk--/main.h>
#include <gtk--/window.h>
#include <unistd.h>
#include <vector>
#include "file_browser.h"
#include "popups.h"
/**
  *@author red
  */

#ifndef WIN32_ENABLED


class FileSelectWidget : public Gtk::Window {
public:
 	enum Mode {

		SAVE,
		LOAD,
  		LOAD_MANY
	};

	enum Action {
                WAITING,
		OK,
		CANCEL
	};

        struct FilterRule {

		vector<string> rules;
  		string description;
        };
private:
        void button_action_pressed();
	FileBrowser browser;

	vector<FilterRule> filter_rules; 	

        Gtk::Main *kit;

	Gtk::Button *button_parent;
	Gtk::Entry *entry_directory;
	Gtk::Button *button_makedir;
	Gtk::HBox *hbox1;
	Gtk::HBox *action_area;
	Gtk::CList *clist_directories;
	Gtk::ScrolledWindow *scrolledwindow1;
	Gtk::VSeparator *vseparator1;
	Gtk::CList *clist_files;
	Gtk::ScrolledWindow *scrolledwindow2;
	Gtk::HBox *hbox2;
	Gtk::Label *label3;
	Gtk::Label *label4;
	Gtk::Entry *entry_file;
	Gtk::Button *button3;
	Gtk::Button *button4;
	Gtk::OptionMenu *optionmenu_filter;
	Gtk::Table *table1;
	Gtk::VBox *vbox1;

   	void on_button_parent_clicked();
        void on_button_makedir_clicked();
        void on_clist_directories_select_row(gint row, gint column, GdkEvent *event);
        void on_clist_files_select_row(gint row, gint column, GdkEvent *event);
        void on_button3_clicked();
        void on_button4_clicked();
        void select_filter(int p_which);
        bool match_with_current_rule(string p_what);

        vector<Gtk::MenuItem*> extension_item;
	Gtk::Menu *_m;
        void update_files();

	gint delete_event_impl(GdkEventAny* p_event) {

		action=CANCEL;
		return 1;
	}

 	int current_rule;

        Action action;
        Mode mode;
public:

	void set_mode(Mode p_mode);
	Action get_action();
	string get_filename();
  	list<string> get_list_of_filenames();

 	Gtk::HBox *get_action_area();
 	void add_filter_rule(FilterRule &filter_rule);


	void poll_until_action(Gtk::Main &p_kit);
	FileSelectWidget();
	~FileSelectWidget();
};

#else

typedef File_Access_Widget FileSelectWidget ;


#endif

#endif
