/***************************************************************************
                          interface.cpp  -  description
                             -------------------
    begin                : Fri Jul 5 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "interface.h"
const char* Interface::notes[128] = {

	"C-0", "C#0", "D-0", "D#0", "E-0", "F-0", "F#0", "G-0", "G#0", "A-0", "A#0", "B-0",
	"C-1", "C#1", "D-1", "D#1", "E-1", "F-1", "F#1", "G-1", "G#1", "A-1", "A#1", "B-1",
	"C-2", "C#2", "D-2", "D#2", "E-2", "F-2", "F#2", "G-2", "G#2", "A-2", "A#2", "B-2",
	"C-3", "C#3", "D-3", "D#3", "E-3", "F-3", "F#3", "G-3", "G#3", "A-3", "A#3", "B-3",
	"C-4", "C#4", "D-4", "D#4", "E-4", "F-4", "F#4", "G-4", "G#4", "A-4", "A#4", "B-4",
	"C-5", "C#5", "D-5", "D#5", "E-5", "F-5", "F#5", "G-5", "G#5", "A-5", "A#5", "B-5",
	"C-6", "C#6", "D-6", "D#6", "E-6", "F-6", "F#6", "G-6", "G#6", "A-6", "A#6", "B-6",
	"C-7", "C#7", "D-7", "D#7", "E-7", "F-7", "F#7", "G-7", "G#7", "A-7", "A#7", "B-7",
	"C-8", "C#8", "D-8", "D#8", "E-8", "F-8", "F#8", "G-8", "G#8", "A-8", "A#8", "B-8",
	"C-9", "C#9", "D-9", "D#9", "E-9", "F-9", "F#9", "G-9", "G#9", "A-9", "A#9", "B-9",
	"C-A", "C#A", "D-A", "D#A", "E-A", "F-A", "F#A", "G-A"
};
	
Interface::Interface() : Gtk::Window(GTK_WINDOW_TOPLEVEL) {

	button_device_add_drum = new Gtk::Button("Add Drums");
	button_device_add_drum->show();
	button_device_delete_drum = new Gtk::Button("Delete Drums");
	button_device_delete_drum->show();
	button_device_add_drum->clicked.connect(SigC::slot(this,&Interface::on_drum_add));
	button_device_delete_drum->clicked.connect(SigC::slot(this,&Interface::on_drum_delete));


	table7 = new Gtk::Table(4, 4, false);
	frame15 = new Gtk::Frame("Display Osciloscopes:");
	label35 = new Gtk::Label("Chan 1-");
	label36 = new Gtk::Label("Chan 2-");
	label37 = new Gtk::Label("Chan 3-");
	label38 = new Gtk::Label("Chan 4-");
	label39 = new Gtk::Label("Chan 5-");
	label40 = new Gtk::Label("Chan 6-");
	entry_info_chan_1 = new Gtk::Entry();
	label41 = new Gtk::Label("Voices:");
        vseparator1 = new Gtk::VSeparator();
        label42 = new Gtk::Label("Chan 7-");
        label43 = new Gtk::Label("Chan 8-");
        entry_info_chan_2 = new Gtk::Entry();
        entry_info_chan_3 = new Gtk::Entry();
        entry_info_chan_4 = new Gtk::Entry();
        entry_info_chan_5 = new Gtk::Entry();
        entry_infp_chan_6 = new Gtk::Entry();
        entry_info_chan_7 = new Gtk::Entry();
        entry_info_chan_8 = new Gtk::Entry();
        label44 = new Gtk::Label("Chan 9-");
        label45 = new Gtk::Label("Chan 10-");
        label46 = new Gtk::Label("Chan 11-");
        label47 = new Gtk::Label("Chan 12-");
        label48 = new Gtk::Label("Chan 13-");
        label49 = new Gtk::Label("Chan 14-");
        label50 = new Gtk::Label("Chan 15-");
        label51 = new Gtk::Label("Chan 16-");
        entry_info_voices = new Gtk::Entry();
        label52 = new Gtk::Label("Event Cnt.:");
        entry_info_events = new Gtk::Entry();
        label53 = new Gtk::Label("Latency:");
        label54 = new Gtk::Label("Cpu %:");
        entry_info_latency = new Gtk::Entry();
        entry_info_cpu = new Gtk::Entry();
        entry_info_chan_10 = new Gtk::Entry();
        entry_info_chan_9 = new Gtk::Entry();
        entry_info_chan_11 = new Gtk::Entry();
        entry_info_chan_12 = new Gtk::Entry();
        entry_info_chan_13 = new Gtk::Entry();
        entry_info_chan_14 = new Gtk::Entry();
        entry_info_chan_15 = new Gtk::Entry();
        entry_info_chan16 = new Gtk::Entry();
        table8 = new Gtk::Table(8, 6, false);
        frame14 = new Gtk::Frame("Status:");
        vbox6 = new Gtk::VBox(false, 0);
        label34 = new Gtk::Label("Info");
        clist_device_banks = new Gtk::CList(4);
        scrolledwindow1 = new Gtk::ScrolledWindow();
//        Gtk::RadioButton::Group _RadioBGroup_;
        radiobutton_device_bank_type_instrument = new Gtk::RadioButton("Insturment Bank"/*, 0, 0.5*/);
        radiobutton_device_bank_type_drum = new Gtk::RadioButton("Drum Bank");
        radiobutton_device_bank_type_drum->set_group(radiobutton_device_bank_type_instrument->group()); 
//        radiobutton_device_bank_type_instrument = new Gtk::RadioButton(_RadioBGroup_, "Insturment Bank", 0, 0.5);
///       radiobutton_device_bank_type_drum = new Gtk::RadioButton(_RadioBGroup_, "Drum Bank", 0, 0.5);
        hbox2 = new Gtk::HBox(false, 0);
        frame2 = new Gtk::Frame("Type");
        label8 = new Gtk::Label("Type:");
        entry_device_bank_engine = new Gtk::Entry();
        label9 = new Gtk::Label("Name:");
        entry_device_bank_name = new Gtk::Entry();
        table2 = new Gtk::Table(2, 2, true);
        frame4 = new Gtk::Frame("Data:");
        frame3 = new Gtk::Frame();
        label10 = new Gtk::Label("Clipboard:");
        hseparator1 = new Gtk::HSeparator();
        button_bank_copy = new Gtk::Button("Copy");
        button_bank_paste = new Gtk::Button("Paste");
        button_bank_moveup = new Gtk::Button("Move Up");
        button_bank_movedown = new Gtk::Button("Move Down");
        label11 = new Gtk::Label("Bank:");
        hseparator2 = new Gtk::HSeparator();
        button_bank_load = new Gtk::Button("Load");
        button_bank_save = new Gtk::Button("Save");
        button_bank_delete = new Gtk::Button("Delete");
        optionmenu_bank_engine = new Interface_Widget_OptionSelect;
        hseparator3 = new Gtk::HSeparator();
        button_bank_new = new Gtk::Button("New");
        hseparator4 = new Gtk::HSeparator();
        table3 = new Gtk::Table(5, 4, true);
        frame5 = new Gtk::Frame("Commands:");
        label65 = new Gtk::Label("File:");
        button_device_new = new Gtk::Button("New");
        button_device_load = new Gtk::Button("Load");
        button_device_save = new Gtk::Button("Save");
        hseparator7 = new Gtk::HSeparator();
        entry_device_file_name = new Gtk::Entry();
        button_device_browse = new Gtk::Button("Browse");
        table11 = new Gtk::Table(2, 4, false);
        frame16 = new Gtk::Frame("Device:");
        vbox1 = new Gtk::VBox(false, 0);
        frame1 = new Gtk::Frame("Bank properties:");
        hbox1 = new Gtk::HBox(false, 0);
        label1 = new Gtk::Label("Banks");
        clist_bank_patch = new Gtk::CList(4);
        scrolledwindow2 = new Gtk::ScrolledWindow();
        frame6 = new Gtk::Frame("Patch List:");
        button_bank_patch_copy = new Gtk::Button("Copy");
        button_bank_patch_paste = new Gtk::Button("Paste");
        button_bank_patch_moveup = new Gtk::Button("Load");
        button_bank_patch_movdwon = new Gtk::Button("Save");
        label20b = new Gtk::Label("Patch Name:");
        label21b = new Gtk::Label("Drum Key Note:");
        label22 = new Gtk::Label("Type:");
        entry_bank_type = new Gtk::Entry();
        entry_bank_patch_name = new Gtk::Entry();
        spinbutton_bank_number_adj = new Gtk::Adjustment(69, 0, 127, 1, 10, 10);
        spinbutton_bank_number = new Gtk::SpinButton(*spinbutton_bank_number_adj, 1, 0);
        table4 = new Gtk::Table(3, 4, true);
        vbox3 = new Gtk::VBox(false, 0);
        hbox3 = new Gtk::HBox(false, 0);
        vbox2 = new Gtk::VBox(false, 0);
        label20 = new Gtk::Label("Patch List");
        fram_bank_patchconfig_container = new Gtk::Frame("Options");
        fram_bank_patchconfig_container->add(dynamic_config);
        dynamic_config.show();
        frame8 = new Gtk::Frame();
        label21 = new Gtk::Label("Patch Config");
        notebook4 = new Gtk::Notebook();
        drawingarea_bank_patch_waveform = new Gtk::DrawingArea();
        frame11 = new Gtk::Frame("Waveform Preview");
        frame10 = new Gtk::Frame();
        label69 = new Gtk::Label("Zoom (1 sec. max):");
        hscale_bank_patch_zoom_adj = new Gtk::Adjustment(100, 1, 100, 10, 10, 0);
        hscale_bank_patch_zoom = new Gtk::HScale(*hscale_bank_patch_zoom_adj);
        hscale_bank_patch_zoom_adj->value_changed.connect(SigC::slot(this,&Interface::on_patch_zoom_changed));
        hbox8 = new Gtk::HBox(false, 0);
        vbox3b = new Gtk::VBox(false, 0);
        label2 = new Gtk::Label("Patch List");
        checkbutton_config_output_16bits = new Gtk::CheckButton("16 bits", 0, 0.5);
        checkbutton_config_output_stereo = new Gtk::CheckButton("Stereo", 0, 0.5);
        radiobutton_config_output_enabled = new Gtk::RadioButton(_RadioBGroup_, "Enabled", 0, 0.5);
        radiobutton_config_output_disabled = new Gtk::RadioButton(_RadioBGroup_, "Disabled", 0, 0.5);
        label28 = new Gtk::Label("Frequency\n(hz)");
        optionmenu_config_output_frequency = new Gtk::Combo;
        clist_config_audio_driver_list = new Gtk::CList(1);
        scrolledwindow3 = new Gtk::ScrolledWindow();
        hseparator5 = new Gtk::HSeparator();
        hseparator6 = new Gtk::HSeparator();
        label29 = new Gtk::Label("Filename:");
        label30 = new Gtk::Label("(loging drivers only)");
        entry_output_log_file_name = new Gtk::Entry();
        button_config_output_log_file_name_browse = new Gtk::Button("Browse");
        table5 = new Gtk::Table(6, 3, false);
        frame12 = new Gtk::Frame("Output Device Properties:");
        label55 = new Gtk::Label("Room:");
        label56 = new Gtk::Label("Damp:");
        label57 = new Gtk::Label("Wet:");
        label58 = new Gtk::Label("Dry(amp+):");
        label59 = new Gtk::Label("Width:");
        hscale_config_reverb_room_adj = new Gtk::Adjustment(0, 0, 1, 0.1, 0.3, 0);
        hscale_config_reverb_room = new Gtk::HScale(*hscale_config_reverb_room_adj);
        hscale_config_reverb_room_adj->value_changed.connect(SigC::slot(this,&Interface::on_reverb_parameters_changed));
        hscale_config_reverb_damp_adj = new Gtk::Adjustment(0, 0, 1, 0.1, 0.3, 0);
        hscale_config_reverb_damp = new Gtk::HScale(*hscale_config_reverb_damp_adj);
        hscale_config_reverb_damp_adj->value_changed.connect(SigC::slot(this,&Interface::on_reverb_parameters_changed));
        hscale_config_reverb_wet_adj = new Gtk::Adjustment(0, 0, 1, 0.1, 0.3, 0);
        hscale_config_reverb_wet = new Gtk::HScale(*hscale_config_reverb_wet_adj);
        hscale_config_reverb_wet_adj->value_changed.connect(SigC::slot(this,&Interface::on_reverb_parameters_changed));
        hscale_config_reverb_dry_adj = new Gtk::Adjustment(0, 0, 1, 0.1, 0.3, 0);
        hscale_config_reverb_dry = new Gtk::HScale(*hscale_config_reverb_dry_adj);
        hscale_config_reverb_dry_adj->value_changed.connect(SigC::slot(this,&Interface::on_reverb_parameters_changed));
        hscale_config_reverb_width_adj = new Gtk::Adjustment(0, 0, 1, 0.1, 0.3, 0);
        hscale_config_reverb_width = new Gtk::HScale(*hscale_config_reverb_width_adj);
        hscale_config_reverb_width_adj->value_changed.connect(SigC::slot(this,&Interface::on_reverb_parameters_changed));
        table9 = new Gtk::Table(5, 2, true);
        label33 = new Gtk::Label("Reverb");
        label60 = new Gtk::Label("Delay (ms):");
        label61 = new Gtk::Label("Speed (hz):");
        label62 = new Gtk::Label("Depth (ms):");
        label63 = new Gtk::Label("Feedback (%):");
        label64 = new Gtk::Label("Width (%):");
        hscale6_adj = new Gtk::Adjustment(1, 1, 50, 1, 10, 0);
        hscale6 = new Gtk::HScale(*hscale6_adj);
        hscale6_adj->value_changed.connect(SigC::slot(this,&Interface::on_chorus_parameters_changed));
        hscale_config_chorus_speed_adj = new Gtk::Adjustment(1, 1, 100, 1, 10, 0);
        hscale_config_chorus_speed = new Gtk::HScale(*hscale_config_chorus_speed_adj);
        hscale_config_chorus_speed_adj->value_changed.connect(SigC::slot(this,&Interface::on_chorus_parameters_changed));
        hscale_config_chorus_depth_adj = new Gtk::Adjustment(0.1, 0.1, 20, 0.1, 1, 0);
        hscale_config_chorus_depth = new Gtk::HScale(*hscale_config_chorus_depth_adj);
        hscale_config_chorus_depth_adj->value_changed.connect(SigC::slot(this,&Interface::on_chorus_parameters_changed));
        hscale_config_chorus_feedback_adj = new Gtk::Adjustment(0, 0, 100, 1, 10, 0);
        hscale_config_chorus_feedback = new Gtk::HScale(*hscale_config_chorus_feedback_adj);
        hscale_config_chorus_feedback_adj->value_changed.connect(SigC::slot(this,&Interface::on_chorus_parameters_changed));
        hscale_config_chorus_width_adj = new Gtk::Adjustment(0, -100, 100, 1, 10, 0);
        hscale_config_chorus_width = new Gtk::HScale(*hscale_config_chorus_width_adj);
        hscale_config_chorus_width_adj->value_changed.connect(SigC::slot(this,&Interface::on_chorus_parameters_changed));
        table10 = new Gtk::Table(5, 2, false);
        hscale_config_chorus_delay = new Gtk::Label("Chorus");
        notebook5 = new Gtk::Notebook();
        frame13 = new Gtk::Frame("Send Buffer Effects:");
        hbox4 = new Gtk::HBox(false, 0);
        clist_config_synth_engine_list = new Gtk::CList(1);
        scrolledwindow4 = new Gtk::ScrolledWindow();
        frame_output_synth_engine_properties_container = new Gtk::Frame("Properties:");
        hbox7 = new Gtk::HBox(false, 0);
        frame17 = new Gtk::Frame("Synth Engines");
        label67 = new Gtk::Label("Refresh Rate:");
        spinbutton_config_gui_refresh_rate_adj = new Gtk::Adjustment(1, 1, 20, 1, 10, 10);
        spinbutton_config_gui_refresh_rate = new Gtk::SpinButton(*spinbutton_config_gui_refresh_rate_adj, 1, 0);

	label_config_preamp = new Gtk::Label("Mixer Preamp:");
	scale_config_preamp_adj = new Gtk::Adjustment(1.0, 0, 4.0, 0.01, 0.01);
	scale_config_preamp = new Gtk::HScale(*scale_config_preamp_adj);
	label_config_preamp->show();
	scale_config_preamp->show();
	
	label_config_drums_channel = new Gtk::Label("Drums Channel:");
	spinbutton_config_drums_channel_adj = new Gtk::Adjustment(10, 1, 16, 1, 5, 5);
	spinbutton_config_drums_channel = new Gtk::SpinButton(*spinbutton_config_drums_channel_adj,1,0);
        label_config_drums_channel->show();
        spinbutton_config_drums_channel->show();

        
	scale_config_preamp_adj->value_changed.connect(SigC::slot(this,&Interface::on_scale_config_preamp_changed));
        spinbutton_config_drums_channel_adj->value_changed.connect(SigC::slot(this,&Interface::on_spinbutton_config_drums_channel_changed));
        
        table12 = new Gtk::Table(3, 2, false);
        frame19 = new Gtk::Frame("Misc:");
        hbox6 = new Gtk::HBox(false, 0);
        vbox4 = new Gtk::VBox(false, 0);
        label3 = new Gtk::Label("Config");
        notebook1 = new Gtk::Notebook();
        table7->set_row_spacings(0);
        table7->set_col_spacings(0);
        frame15->set_shadow_type(GTK_SHADOW_ETCHED_IN);
        frame15->set_label_align(0,0);
        frame15->add(*table7);
        label35->set_alignment(0,0.5);
        label35->set_padding(0,0);
        label35->set_justify(GTK_JUSTIFY_CENTER);
        label35->set_line_wrap(false);
        label36->set_alignment(0,0.5);
        label36->set_padding(0,0);
        label36->set_justify(GTK_JUSTIFY_CENTER);
        label36->set_line_wrap(false);
        label37->set_alignment(0,0.5);
        label37->set_padding(0,0);
        label37->set_justify(GTK_JUSTIFY_CENTER);
        label37->set_line_wrap(false);
        label38->set_alignment(0,0.5);
        label38->set_padding(0,0);
        label38->set_justify(GTK_JUSTIFY_CENTER);
        label38->set_line_wrap(false);
        label39->set_alignment(0,0.5);
        label39->set_padding(0,0);
        label39->set_justify(GTK_JUSTIFY_CENTER);
        label39->set_line_wrap(false);
        label40->set_alignment(0,0.5);
        label40->set_padding(0,0);
        label40->set_justify(GTK_JUSTIFY_CENTER);
        label40->set_line_wrap(false);
        entry_info_chan_1->set_flags(GTK_CAN_FOCUS);
        entry_info_chan_1->set_visibility(true);
        entry_info_chan_1->set_editable(false);
        entry_info_chan_1->set_text("");
        label41->set_alignment(0,0.5);
        label41->set_padding(0,0);
        label41->set_justify(GTK_JUSTIFY_CENTER);
        label41->set_line_wrap(false);
        vseparator1->set_usize(9,-1);
        label42->set_alignment(0,0.5);
        label42->set_padding(0,0);
        label42->set_justify(GTK_JUSTIFY_CENTER);
        label42->set_line_wrap(false);
        label43->set_alignment(0,0.5);
        label43->set_padding(0,0);
        label43->set_justify(GTK_JUSTIFY_CENTER);
        label43->set_line_wrap(false);
        entry_info_chan_2->set_flags(GTK_CAN_FOCUS);
        entry_info_chan_2->set_visibility(true);
        entry_info_chan_2->set_editable(false);
        entry_info_chan_2->set_text("");
        entry_info_chan_3->set_flags(GTK_CAN_FOCUS);
        entry_info_chan_3->set_visibility(true);
        entry_info_chan_3->set_editable(false);
        entry_info_chan_3->set_text("");
        entry_info_chan_4->set_flags(GTK_CAN_FOCUS);
        entry_info_chan_4->set_visibility(true);
        entry_info_chan_4->set_editable(false);
        entry_info_chan_4->set_text("");
        entry_info_chan_5->set_flags(GTK_CAN_FOCUS);
        entry_info_chan_5->set_visibility(true);
        entry_info_chan_5->set_editable(false);
        entry_info_chan_5->set_text("");
        entry_infp_chan_6->set_flags(GTK_CAN_FOCUS);
        entry_infp_chan_6->set_visibility(true);
        entry_infp_chan_6->set_editable(false);
        entry_infp_chan_6->set_text("");
        entry_info_chan_7->set_flags(GTK_CAN_FOCUS);
        entry_info_chan_7->set_visibility(true);
        entry_info_chan_7->set_editable(false);
        entry_info_chan_7->set_text("");
        entry_info_chan_8->set_flags(GTK_CAN_FOCUS);
        entry_info_chan_8->set_visibility(true);
        entry_info_chan_8->set_editable(false);
        entry_info_chan_8->set_text("");
        label44->set_alignment(0,0.5);
        label44->set_padding(0,0);
        label44->set_justify(GTK_JUSTIFY_CENTER);
        label44->set_line_wrap(false);
        label45->set_alignment(0,0.5);
        label45->set_padding(0,0);
        label45->set_justify(GTK_JUSTIFY_CENTER);
        label45->set_line_wrap(false);
        label46->set_alignment(0,0.5);
        label46->set_padding(0,0);
        label46->set_justify(GTK_JUSTIFY_CENTER);
        label46->set_line_wrap(false);
        label47->set_alignment(0,0.5);
        label47->set_padding(0,0);
        label47->set_justify(GTK_JUSTIFY_CENTER);
        label47->set_line_wrap(false);
        label48->set_alignment(0,0.5);
        label48->set_padding(0,0);
        label48->set_justify(GTK_JUSTIFY_CENTER);
        label48->set_line_wrap(false);
        label49->set_alignment(0,0.5);
        label49->set_padding(0,0);
        label49->set_justify(GTK_JUSTIFY_CENTER);
        label49->set_line_wrap(false);
        label50->set_alignment(0,0.5);
        label50->set_padding(0,0);
        label50->set_justify(GTK_JUSTIFY_CENTER);
        label50->set_line_wrap(false);
        label51->set_alignment(0,0.5);
        label51->set_padding(0,0);
        label51->set_justify(GTK_JUSTIFY_CENTER);
        label51->set_line_wrap(false);
        entry_info_voices->set_usize(74,-1);
        entry_info_voices->set_flags(GTK_CAN_FOCUS);
        entry_info_voices->set_visibility(true);
        entry_info_voices->set_editable(false);
        entry_info_voices->set_text("");
        label52->set_alignment(0,0.5);
        label52->set_padding(0,0);
        label52->set_justify(GTK_JUSTIFY_CENTER);
        label52->set_line_wrap(false);
        entry_info_events->set_usize(74,-1);
        entry_info_events->set_flags(GTK_CAN_FOCUS);
        entry_info_events->set_visibility(true);
        entry_info_events->set_editable(false);
        entry_info_events->set_text("");
        label53->set_alignment(0,0.5);
        label53->set_padding(0,0);
        label53->set_justify(GTK_JUSTIFY_CENTER);
        label53->set_line_wrap(false);
        label54->set_alignment(0,0.5);
        label54->set_padding(0,0);
        label54->set_justify(GTK_JUSTIFY_CENTER);
        label54->set_line_wrap(false);
        entry_info_latency->set_usize(74,-1);
        entry_info_latency->set_flags(GTK_CAN_FOCUS);
        entry_info_latency->set_visibility(true);
        entry_info_latency->set_editable(false);
        entry_info_latency->set_text("");
        entry_info_cpu->set_usize(74,-1);
        entry_info_cpu->set_flags(GTK_CAN_FOCUS);
        entry_info_cpu->set_visibility(true);
        entry_info_cpu->set_editable(false);
        entry_info_cpu->set_text("");
        entry_info_chan_10->set_flags(GTK_CAN_FOCUS);
        entry_info_chan_10->set_visibility(true);
        entry_info_chan_10->set_editable(false);
        entry_info_chan_10->set_text("");
        entry_info_chan_9->set_flags(GTK_CAN_FOCUS);
        entry_info_chan_9->set_visibility(true);
        entry_info_chan_9->set_editable(false);
        entry_info_chan_9->set_text("");
        entry_info_chan_11->set_flags(GTK_CAN_FOCUS);
        entry_info_chan_11->set_visibility(true);
        entry_info_chan_11->set_editable(false);
        entry_info_chan_11->set_text("");
        entry_info_chan_12->set_flags(GTK_CAN_FOCUS);
        entry_info_chan_12->set_visibility(true);
        entry_info_chan_12->set_editable(false);
        entry_info_chan_12->set_text("");
        entry_info_chan_13->set_flags(GTK_CAN_FOCUS);
        entry_info_chan_13->set_visibility(true);
        entry_info_chan_13->set_editable(false);
        entry_info_chan_13->set_text("");
        entry_info_chan_14->set_flags(GTK_CAN_FOCUS);
        entry_info_chan_14->set_visibility(true);
        entry_info_chan_14->set_editable(false);
        entry_info_chan_14->set_text("");
        entry_info_chan_15->set_flags(GTK_CAN_FOCUS);
        entry_info_chan_15->set_visibility(true);
        entry_info_chan_15->set_editable(false);
        entry_info_chan_15->set_text("");
        entry_info_chan16->set_flags(GTK_CAN_FOCUS);
        entry_info_chan16->set_visibility(true);
        entry_info_chan16->set_editable(false);
        entry_info_chan16->set_text("");
        table8->set_row_spacings(0);
        table8->set_col_spacings(0);
        table8->attach(*label35, 2, 3, 0, 1, GTK_FILL, 0, 0, 0);
        table8->attach(*label36, 2, 3, 1, 2, GTK_FILL, 0, 0, 0);
        table8->attach(*label37, 2, 3, 2, 3, GTK_FILL, 0, 0, 0);
        table8->attach(*label38, 2, 3, 3, 4, GTK_FILL, 0, 0, 0);
        table8->attach(*label39, 2, 3, 4, 5, GTK_FILL, 0, 0, 0);
        table8->attach(*label40, 2, 3, 5, 6, GTK_FILL, 0, 0, 0);
        table8->attach(*entry_info_chan_1, 3, 4, 0, 1, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table8->attach(*label41, 0, 1, 0, 1, GTK_FILL, 0, 0, 0);
        table8->attach(*vseparator1, 1, 2, 0, 8, GTK_FILL, GTK_FILL, 0, 0);
        table8->attach(*label42, 2, 3, 6, 7, GTK_FILL, 0, 0, 0);
        table8->attach(*label43, 2, 3, 7, 8, GTK_FILL, 0, 0, 0);
        table8->attach(*entry_info_chan_2, 3, 4, 1, 2, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table8->attach(*entry_info_chan_3, 3, 4, 2, 3, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table8->attach(*entry_info_chan_4, 3, 4, 3, 4, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table8->attach(*entry_info_chan_5, 3, 4, 4, 5, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table8->attach(*entry_infp_chan_6, 3, 4, 5, 6, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table8->attach(*entry_info_chan_7, 3, 4, 6, 7, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table8->attach(*entry_info_chan_8, 3, 4, 7, 8, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table8->attach(*label44, 4, 5, 0, 1, GTK_FILL, 0, 0, 0);
        table8->attach(*label45, 4, 5, 1, 2, GTK_FILL, 0, 0, 0);
        table8->attach(*label46, 4, 5, 2, 3, GTK_FILL, 0, 0, 0);
        table8->attach(*label47, 4, 5, 3, 4, GTK_FILL, 0, 0, 0);
        table8->attach(*label48, 4, 5, 4, 5, GTK_FILL, 0, 0, 0);
        table8->attach(*label49, 4, 5, 5, 6, GTK_FILL, 0, 0, 0);
        table8->attach(*label50, 4, 5, 6, 7, GTK_FILL, 0, 0, 0);
        table8->attach(*label51, 4, 5, 7, 8, GTK_FILL, 0, 0, 0);
        table8->attach(*entry_info_voices, 0, 1, 1, 2, GTK_FILL, 0, 0, 0);
        table8->attach(*label52, 0, 1, 2, 3, GTK_FILL, 0, 0, 0);
        table8->attach(*entry_info_events, 0, 1, 3, 4, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table8->attach(*label53, 0, 1, 4, 5, GTK_FILL, 0, 0, 0);
        table8->attach(*label54, 0, 1, 6, 7, GTK_FILL, 0, 0, 0);
        table8->attach(*entry_info_latency, 0, 1, 5, 6, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table8->attach(*entry_info_cpu, 0, 1, 7, 8, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table8->attach(*entry_info_chan_10, 5, 6, 1, 2, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table8->attach(*entry_info_chan_9, 5, 6, 0, 1, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table8->attach(*entry_info_chan_11, 5, 6, 2, 3, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table8->attach(*entry_info_chan_12, 5, 6, 3, 4, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table8->attach(*entry_info_chan_13, 5, 6, 4, 5, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table8->attach(*entry_info_chan_14, 5, 6, 5, 6, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table8->attach(*entry_info_chan_15, 5, 6, 6, 7, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table8->attach(*entry_info_chan16, 5, 6, 7, 8, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        frame14->set_shadow_type(GTK_SHADOW_ETCHED_IN);
        frame14->set_label_align(0,0);
        frame14->add(*table8);
        vbox6->pack_start(*frame15);
        vbox6->pack_start(*frame14, false, true, 0);
        label34->set_alignment(0.5,0.5);
        label34->set_padding(0,0);
        label34->set_justify(GTK_JUSTIFY_CENTER);
        label34->set_line_wrap(false);
        clist_device_banks->set_flags(GTK_CAN_FOCUS);
        clist_device_banks->set_column_title(0, "#");
        clist_device_banks->set_column_justification(0, GTK_JUSTIFY_CENTER);
        clist_device_banks->set_column_width(0, 21);
        clist_device_banks->set_column_title(1, "Type");
        clist_device_banks->set_column_justification(1, GTK_JUSTIFY_CENTER);
        clist_device_banks->set_column_width(1, 84);
        clist_device_banks->set_column_title(2, "Bank");
        clist_device_banks->set_column_justification(2, GTK_JUSTIFY_CENTER);
        clist_device_banks->set_column_width(2, 74);
        clist_device_banks->set_column_title(3, "Name");
        clist_device_banks->set_column_justification(3, GTK_JUSTIFY_CENTER);
        clist_device_banks->set_column_width(3, 80);
        clist_device_banks->set_selection_mode(GTK_SELECTION_SINGLE);
        clist_device_banks->column_titles_show();
        scrolledwindow1->set_policy(GTK_POLICY_ALWAYS, GTK_POLICY_ALWAYS);
//        scrolledwindow1->add(*clist_device_banks);
	scrolledwindow1->add_with_viewport(bank_tree);
	bank_tree.show();
        radiobutton_device_bank_type_instrument->set_flags(GTK_CAN_FOCUS);
        radiobutton_device_bank_type_instrument->set_mode(true);
        radiobutton_device_bank_type_instrument->set_active(false);
        radiobutton_device_bank_type_drum->set_flags(GTK_CAN_FOCUS);
        radiobutton_device_bank_type_drum->set_mode(true);
        radiobutton_device_bank_type_drum->set_active(false);
        hbox2->set_border_width(4);
        hbox2->pack_start(*radiobutton_device_bank_type_instrument, false, false, 0);
        hbox2->pack_start(*radiobutton_device_bank_type_drum, false, false, 0);
        frame2->set_shadow_type(GTK_SHADOW_ETCHED_IN);
        frame2->set_label_align(0,0);
        frame2->add(*hbox2);
        label8->set_alignment(0,0.5);
        label8->set_padding(0,0);
        label8->set_justify(GTK_JUSTIFY_CENTER);
        label8->set_line_wrap(false);
        entry_device_bank_engine->set_flags(GTK_CAN_FOCUS);
        entry_device_bank_engine->set_visibility(true);
        entry_device_bank_engine->set_editable(false);
        entry_device_bank_engine->set_text("DX7");
        label9->set_alignment(0,0.5);
        label9->set_padding(0,0);
        label9->set_justify(GTK_JUSTIFY_CENTER);
        label9->set_line_wrap(false);
        entry_device_bank_name->set_flags(GTK_CAN_FOCUS);
        entry_device_bank_name->set_visibility(true);
        entry_device_bank_name->set_editable(true);
        entry_device_bank_name->set_text("");
        table2->set_row_spacings(0);
        table2->set_col_spacings(0);
        table2->attach(*label8, 0, 1, 0, 1, GTK_FILL, 0, 0, 0);
        table2->attach(*entry_device_bank_engine, 1, 2, 0, 1, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table2->attach(*label9, 0, 1, 1, 2, GTK_FILL, 0, 0, 0);
        table2->attach(*entry_device_bank_name, 1, 2, 1, 2, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        frame4->set_shadow_type(GTK_SHADOW_ETCHED_IN);
        frame4->set_label_align(0,0);
        frame4->add(*table2);
        frame3->set_shadow_type(GTK_SHADOW_ETCHED_IN);
        frame3->set_label_align(0,0);
        frame3->add(*frame4);
        label10->set_alignment(0,0.5);
        label10->set_padding(0,0);
        label10->set_justify(GTK_JUSTIFY_CENTER);
        label10->set_line_wrap(false);
        button_bank_copy->set_flags(GTK_CAN_FOCUS);
        button_bank_copy->set_relief(GTK_RELIEF_NORMAL);
        button_bank_paste->set_flags(GTK_CAN_FOCUS);
        button_bank_paste->set_relief(GTK_RELIEF_NORMAL);
        button_bank_moveup->set_flags(GTK_CAN_FOCUS);
        button_bank_moveup->set_relief(GTK_RELIEF_NORMAL);
        button_bank_movedown->set_flags(GTK_CAN_FOCUS);
        button_bank_movedown->set_relief(GTK_RELIEF_NORMAL);
        label11->set_alignment(0,0.5);
        label11->set_padding(0,0);
        label11->set_justify(GTK_JUSTIFY_CENTER);
        label11->set_line_wrap(false);
        button_bank_load->set_flags(GTK_CAN_FOCUS);
        button_bank_load->set_relief(GTK_RELIEF_NORMAL);
        button_bank_save->set_flags(GTK_CAN_FOCUS);
        button_bank_save->set_relief(GTK_RELIEF_NORMAL);
        button_bank_delete->set_flags(GTK_CAN_FOCUS);
        button_bank_delete->set_relief(GTK_RELIEF_NORMAL);
        optionmenu_bank_engine->set_flags(GTK_CAN_FOCUS);
        {
/*
        Gtk::Menu *_m(manage(new Gtk::Menu()));
        Gtk::MenuItem *_mi;
        _mi = manage(new Gtk::MenuItem("DX7"));
        _m->append(*_mi);
        _mi->show();
        _mi->set_user_data((gpointer)0);
        _mi = manage(new Gtk::MenuItem("SID"));
        _m->append(*_mi);
        _mi->show();
        _mi->set_user_data((gpointer)1);
        _mi = manage(new Gtk::MenuItem("YMH2162"));
        _m->append(*_mi);
        _mi->show();
        _mi->set_user_data((gpointer)2);
        optionmenu_bank_engine->set_menu(*_m);
        optionmenu_bank_engine->set_history(1);*/
        }
        button_bank_new->set_flags(GTK_CAN_FOCUS);
        button_bank_new->set_relief(GTK_RELIEF_NORMAL);
        table3->set_row_spacings(0);
        table3->set_col_spacings(0);
        table3->attach(*label10, 0, 1, 0, 1, GTK_FILL, 0, 0, 0);
        table3->attach(*hseparator1, 1, 4, 0, 1, GTK_EXPAND|GTK_FILL, GTK_FILL, 0, 0);
        table3->attach(*button_bank_copy, 0, 1, 1, 2, GTK_FILL, 0, 0, 0);
        table3->attach(*button_bank_paste, 1, 2, 1, 2, GTK_FILL, 0, 0, 0);
        table3->attach(*button_bank_moveup, 2, 3, 1, 2, GTK_FILL, 0, 0, 0);
        table3->attach(*button_bank_movedown, 3, 4, 1, 2, GTK_FILL, 0, 0, 0);
        table3->attach(*label11, 0, 1, 2, 3, GTK_FILL, 0, 0, 0);
        table3->attach(*hseparator2, 1, 4, 2, 3, GTK_FILL, GTK_FILL, 0, 0);
        table3->attach(*button_bank_load, 0, 1, 3, 4, GTK_FILL, 0, 0, 0);
        table3->attach(*button_bank_save, 1, 2, 3, 4, GTK_FILL, 0, 0, 0);
        table3->attach(*button_device_delete_drum, 3, 4, 3, 4, GTK_FILL, 0, 0, 0);
        table3->attach(*optionmenu_bank_engine, 2, 4, 4, 5, GTK_FILL, 0, 0, 0);
        table3->attach(*button_bank_delete, 0, 1, 4, 5, GTK_FILL, GTK_FILL, 0, 0);
        table3->attach(*button_bank_new, 1, 2, 4, 5, GTK_FILL, 0, 0, 0);
        table3->attach(*button_device_add_drum, 2, 3, 3, 4, GTK_FILL, GTK_FILL, 0, 0);
        frame5->set_shadow_type(GTK_SHADOW_ETCHED_IN);
        frame5->set_label_align(0,0);
        frame5->add(*table3);
        label65->set_alignment(0,0.5);
        label65->set_padding(0,0);
        label65->set_justify(GTK_JUSTIFY_CENTER);
        label65->set_line_wrap(false);
        button_device_new->set_flags(GTK_CAN_FOCUS);
        button_device_new->set_relief(GTK_RELIEF_NORMAL);
        button_device_load->set_flags(GTK_CAN_FOCUS);
        button_device_load->set_relief(GTK_RELIEF_NORMAL);
        button_device_save->set_flags(GTK_CAN_FOCUS);
        button_device_save->set_relief(GTK_RELIEF_NORMAL);
        entry_device_file_name->set_flags(GTK_CAN_FOCUS);
        entry_device_file_name->set_visibility(true);
        entry_device_file_name->set_editable(true);
        entry_device_file_name->set_text("");
        button_device_browse->set_flags(GTK_CAN_FOCUS);
        button_device_browse->set_relief(GTK_RELIEF_NORMAL);
        table11->set_border_width(7);
        table11->set_row_spacings(4);
        table11->set_col_spacings(3);
        table11->attach(*label65, 0, 1, 0, 1, GTK_FILL, 0, 0, 0);
        table11->attach(*button_device_new, 0, 1, 1, 2, GTK_FILL, 0, 0, 0);
        table11->attach(*button_device_load, 1, 2, 1, 2, GTK_FILL, 0, 0, 0);
        table11->attach(*button_device_save, 2, 3, 1, 2, GTK_FILL, 0, 0, 0);
        table11->attach(*hseparator7, 3, 4, 1, 2, GTK_FILL, GTK_FILL, 0, 0);
        table11->attach(*entry_device_file_name, 1, 3, 0, 1, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table11->attach(*button_device_browse, 3, 4, 0, 1, GTK_FILL, 0, 0, 0);
        frame16->set_shadow_type(GTK_SHADOW_ETCHED_IN);
        frame16->set_label_align(0,0);
        frame16->add(*table11);
        vbox1->pack_start(*frame2, false, true, 0);
        vbox1->pack_start(*frame3);
        vbox1->pack_start(*frame5);
        vbox1->pack_start(*frame16);
        frame1->set_shadow_type(GTK_SHADOW_ETCHED_IN);
        frame1->set_label_align(0,0);
        frame1->add(*vbox1);
        hbox1->pack_start(*scrolledwindow1);
        hbox1->pack_start(*frame1, false, true, 0);
        label1->set_alignment(0.5,0.5);
        label1->set_padding(0,0);
        label1->set_justify(GTK_JUSTIFY_CENTER);
        label1->set_line_wrap(false);
        clist_bank_patch->set_flags(GTK_CAN_FOCUS);
        clist_bank_patch->set_column_title(0, "#");
        clist_bank_patch->set_column_justification(0, GTK_JUSTIFY_CENTER);
        clist_bank_patch->set_column_width(0, 37);
        clist_bank_patch->set_column_title(1, "P");
        clist_bank_patch->set_column_justification(1, GTK_JUSTIFY_CENTER);
        clist_bank_patch->set_column_width(1, 28);
        clist_bank_patch->set_column_title(2, "Drum Key");
        clist_bank_patch->set_column_justification(2, GTK_JUSTIFY_CENTER);
        clist_bank_patch->set_column_width(2, 71);
        clist_bank_patch->set_column_title(3, "Name");
        clist_bank_patch->set_column_justification(3, GTK_JUSTIFY_CENTER);
        clist_bank_patch->set_column_width(3, 80);
        clist_bank_patch->set_selection_mode(GTK_SELECTION_SINGLE);
        clist_bank_patch->column_titles_show();
        scrolledwindow2->set_policy(GTK_POLICY_ALWAYS, GTK_POLICY_ALWAYS);
        scrolledwindow2->add(*clist_bank_patch);
        frame6->set_shadow_type(GTK_SHADOW_ETCHED_IN);
        frame6->set_label_align(0,0);
        frame6->add(*scrolledwindow2);
        button_bank_patch_copy->set_flags(GTK_CAN_FOCUS);
        button_bank_patch_copy->set_relief(GTK_RELIEF_NORMAL);
        button_bank_patch_paste->set_flags(GTK_CAN_FOCUS);
        button_bank_patch_paste->set_relief(GTK_RELIEF_NORMAL);
        button_bank_patch_moveup->set_flags(GTK_CAN_FOCUS);
        button_bank_patch_moveup->set_relief(GTK_RELIEF_NORMAL);
        button_bank_patch_movdwon->set_flags(GTK_CAN_FOCUS);
        button_bank_patch_movdwon->set_relief(GTK_RELIEF_NORMAL);
        label20->set_alignment(0,0.5);
        label20->set_padding(0,0);
        label20->set_justify(GTK_JUSTIFY_CENTER);
        label20->set_line_wrap(false);
        label21->set_alignment(0,0.5);
        label21->set_padding(0,0);
        label21->set_justify(GTK_JUSTIFY_CENTER);
        label21->set_line_wrap(false);
        label22->set_alignment(0,0.5);
        label22->set_padding(0,0);
        label22->set_justify(GTK_JUSTIFY_CENTER);
        label22->set_line_wrap(false);
        entry_bank_type->set_usize(52,-1);
        entry_bank_type->set_flags(GTK_CAN_FOCUS);
        entry_bank_type->set_visibility(true);
        entry_bank_type->set_editable(false);
        entry_bank_type->set_text("");
        entry_bank_patch_name->set_usize(142,-1);
        entry_bank_patch_name->set_flags(GTK_CAN_FOCUS);
        entry_bank_patch_name->set_visibility(true);
        entry_bank_patch_name->set_editable(true);
        entry_bank_patch_name->set_text("");
        spinbutton_bank_number->set_usize(56,-1);
        spinbutton_bank_number->set_flags(GTK_CAN_FOCUS);
        spinbutton_bank_number->set_update_policy(GTK_UPDATE_ALWAYS);
        spinbutton_bank_number->set_numeric(false);
        spinbutton_bank_number->set_digits(0);
        spinbutton_bank_number->set_wrap(false);
        spinbutton_bank_number->set_snap_to_ticks(false);
        table4->set_row_spacings(0);
        table4->set_col_spacings(0);
        table4->attach(*button_bank_patch_copy, 0, 1, 0, 1, GTK_FILL, 0, 0, 0);
        table4->attach(*button_bank_patch_paste, 1, 2, 0, 1, GTK_FILL, 0, 0, 0);
        table4->attach(*button_bank_patch_moveup, 2, 3, 0, 1, GTK_FILL, 0, 0, 0);
        table4->attach(*button_bank_patch_movdwon, 3, 4, 0, 1, GTK_FILL, 0, 0, 0);
        table4->attach(*label20b, 0, 1, 1, 2, GTK_FILL, 0, 0, 0);
        table4->attach(*label21b, 0, 1, 2, 3, GTK_FILL, 0, 0, 0);
        table4->attach(*label22, 2, 3, 2, 3, GTK_FILL, 0, 0, 0);
        table4->attach(*entry_bank_type, 3, 4, 2, 3, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table4->attach(*entry_bank_patch_name, 1, 4, 1, 2, GTK_FILL, 0, 0, 0);
        table4->attach(*spinbutton_bank_number, 1, 2, 2, 3, 0, 0, 0, 0);
        vbox3b->pack_start(*frame6);
        vbox3b->pack_start(*table4, false, true, 0);
        hbox3->pack_start(*vbox3b);
        vbox2->pack_start(*hbox3);
        label20->set_alignment(0.5,0.5);
        label20->set_padding(0,0);
        label20->set_justify(GTK_JUSTIFY_CENTER);
        label20->set_line_wrap(false);
        fram_bank_patchconfig_container->set_shadow_type(GTK_SHADOW_ETCHED_IN);
        fram_bank_patchconfig_container->set_label_align(0,0);
        frame8->set_shadow_type(GTK_SHADOW_ETCHED_IN);
        frame8->set_label_align(0,0);
        frame8->add(*fram_bank_patchconfig_container);
        label21->set_alignment(0.5,0.5);
        label21->set_padding(0,0);
        label21->set_justify(GTK_JUSTIFY_CENTER);
        label21->set_line_wrap(false);
        notebook4->set_flags(GTK_CAN_FOCUS);
        notebook4->set_show_tabs(true);
        notebook4->set_show_border(true);
        notebook4->set_tab_pos(GTK_POS_TOP);
        notebook4->set_scrollable(false);
        notebook4->popup_disable();
        notebook4->pages().push_back(Gtk::Notebook_Helpers::TabElem(*vbox2, *label20));
        notebook4->pages().push_back(Gtk::Notebook_Helpers::TabElem(*frame8, *label21));
        drawingarea_bank_patch_waveform->set_usize(-1,80);
        frame11->set_shadow_type(GTK_SHADOW_ETCHED_IN);
        frame11->set_label_align(0,0);
//        frame11->add(*drawingarea_bank_patch_waveform);
        frame10->set_shadow_type(GTK_SHADOW_ETCHED_IN);
        frame10->set_label_align(0,0);
        frame10->add(*frame11);
        label69->set_alignment(0.5,0.5);
        label69->set_padding(0,0);
        label69->set_justify(GTK_JUSTIFY_CENTER);
        label69->set_line_wrap(false);
        hscale_bank_patch_zoom->set_flags(GTK_CAN_FOCUS);
        hscale_bank_patch_zoom->set_digits(1);
        hscale_bank_patch_zoom->set_draw_value(true);
        hscale_bank_patch_zoom->set_value_pos(GTK_POS_RIGHT);
        hbox8->pack_start(*label69, false, false, 0);
        hbox8->pack_start(*hscale_bank_patch_zoom);
        vbox3->pack_start(*notebook4);
        vbox3->pack_start(*frame10, false, true, 0);
        vbox3->pack_start(*hbox8, false, true, 0);
        label2->set_alignment(0.5,0.5);
        label2->set_padding(0,0);
        label2->set_justify(GTK_JUSTIFY_CENTER);
        label2->set_line_wrap(false);
        checkbutton_config_output_16bits->set_flags(GTK_CAN_FOCUS);
        checkbutton_config_output_16bits->set_mode(true);
        checkbutton_config_output_16bits->set_active(false);
        checkbutton_config_output_stereo->set_flags(GTK_CAN_FOCUS);
        checkbutton_config_output_stereo->set_mode(true);
        checkbutton_config_output_stereo->set_active(false);
        radiobutton_config_output_enabled->set_flags(GTK_CAN_FOCUS);
        radiobutton_config_output_enabled->set_mode(true);
        radiobutton_config_output_enabled->set_active(false);
        radiobutton_config_output_disabled->set_flags(GTK_CAN_FOCUS);
        radiobutton_config_output_disabled->set_mode(true);
        radiobutton_config_output_disabled->set_active(false);
        label28->set_alignment(0,0.5);
        label28->set_padding(0,0);
        label28->set_justify(GTK_JUSTIFY_CENTER);
        label28->set_line_wrap(false);

        combo_config_buffersize = new Gtk::Combo;
	label_config_buffersize = new Gtk::Label("Buffer Size:\n(Samples)");
        {
	        const char * items[]={"8192","11025","16384","22050","32768","44100","48000",0};
		optionmenu_config_output_frequency->set_popdown_strings(items);
		optionmenu_config_output_frequency->get_entry()->set_editable(false);
		optionmenu_config_output_frequency->get_entry()->changed.connect(SigC::slot(this,&Interface::on_optionmenu_config_output_frequency_changed));
		

	}

        {
	        const char * items[]={"256","512","1024","2048","4096","8192","16384",0};
		combo_config_buffersize->set_popdown_strings(items);
		combo_config_buffersize->show();
		combo_config_buffersize->get_entry()->set_editable(false);
		combo_config_buffersize->get_entry()->changed.connect(SigC::slot(this,&Interface::on_combo_config_buffersize_changed));

	}
	label_config_buffersize->show();
                
     

        clist_config_audio_driver_list->set_flags(GTK_CAN_FOCUS);
        clist_config_audio_driver_list->set_column_title(0, "Driver");
        clist_config_audio_driver_list->set_column_justification(0, GTK_JUSTIFY_CENTER);
        clist_config_audio_driver_list->set_column_width(0, 80);
        clist_config_audio_driver_list->set_selection_mode(GTK_SELECTION_SINGLE);
        clist_config_audio_driver_list->column_titles_show();
        scrolledwindow3->set_policy(GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
        scrolledwindow3->add(*clist_config_audio_driver_list);
        label29->set_alignment(0,0.5);
        label29->set_padding(0,0);
        label29->set_justify(GTK_JUSTIFY_CENTER);
        label29->set_line_wrap(false);
        label30->set_alignment(0,0.5);
        label30->set_padding(0,0);
        label30->set_justify(GTK_JUSTIFY_CENTER);
        label30->set_line_wrap(false);
        entry_output_log_file_name->set_flags(GTK_CAN_FOCUS);
        entry_output_log_file_name->set_visibility(true);
        entry_output_log_file_name->set_editable(true);
        entry_output_log_file_name->set_text("");
        button_config_output_log_file_name_browse->set_flags(GTK_CAN_FOCUS);
        button_config_output_log_file_name_browse->set_relief(GTK_RELIEF_NORMAL);
        table5->set_border_width(6);
        table5->set_row_spacings(3);
        table5->set_col_spacings(4);
        table5->attach(*checkbutton_config_output_16bits, 1, 2, 0, 1, GTK_FILL, 0, 0, 0);
        table5->attach(*checkbutton_config_output_stereo, 1, 2, 1, 2, GTK_FILL, 0, 0, 0);
        
        table5->attach(*radiobutton_config_output_enabled, 1, 2, 4, 5, GTK_FILL, 0, 0, 0);
        table5->attach(*radiobutton_config_output_disabled, 2, 3, 4, 5, GTK_FILL, 0, 0, 0);
        table5->attach(*label28, 1, 2, 2, 3, GTK_FILL, 0, 0, 0);
        table5->attach(*optionmenu_config_output_frequency, 2, 3, 2, 3, GTK_FILL, 0, 0, 0);
        table5->attach(*combo_config_buffersize, 2, 3, 3, 4, GTK_FILL, 0, 0, 0);
        table5->attach(*label_config_buffersize, 1, 2, 3, 4, GTK_FILL, 0, 0, 0);
        table5->attach(*scrolledwindow3, 0, 1, 0, 4, GTK_EXPAND|GTK_FILL, GTK_EXPAND|GTK_FILL, 0, 0);
        table5->attach(*hseparator5, 2, 3, 0, 1, GTK_FILL, GTK_FILL, 0, 0);
        table5->attach(*hseparator6, 2, 3, 1, 2, GTK_FILL, GTK_FILL, 0, 0);
        table5->attach(*label29, 0, 1, 5, 6, GTK_FILL, 0, 0, 0);
        table5->attach(*label30, 1, 3, 5, 6, GTK_FILL, 0, 0, 0);
        table5->attach(*entry_output_log_file_name, 0, 2, 6, 7, GTK_EXPAND|GTK_FILL, 0, 0, 0);
        table5->attach(*button_config_output_log_file_name_browse, 2, 3, 6, 7, GTK_FILL, 0, 0, 0);
        frame12->set_border_width(4);
        frame12->set_shadow_type(GTK_SHADOW_ETCHED_IN);
        frame12->set_label_align(0,0);
        frame12->add(*table5);
        label55->set_alignment(0,0.5);
        label55->set_padding(0,0);
        label55->set_justify(GTK_JUSTIFY_CENTER);
        label55->set_line_wrap(false);
        label56->set_alignment(0,0.5);
        label56->set_padding(0,0);
        label56->set_justify(GTK_JUSTIFY_CENTER);
        label56->set_line_wrap(false);
        label57->set_alignment(0,0.5);
        label57->set_padding(0,0);
        label57->set_justify(GTK_JUSTIFY_CENTER);
        label57->set_line_wrap(false);
        label58->set_alignment(0,0.5);
        label58->set_padding(0,0);
        label58->set_justify(GTK_JUSTIFY_CENTER);
        label58->set_line_wrap(false);
        label59->set_alignment(0,0.5);
        label59->set_padding(0,0);
        label59->set_justify(GTK_JUSTIFY_CENTER);
        label59->set_line_wrap(false);
        hscale_config_reverb_room->set_flags(GTK_CAN_FOCUS);
        hscale_config_reverb_room->set_digits(3);
        hscale_config_reverb_room->set_draw_value(true);
        hscale_config_reverb_room->set_value_pos(GTK_POS_TOP);
        hscale_config_reverb_damp->set_flags(GTK_CAN_FOCUS);
        hscale_config_reverb_damp->set_digits(3);
        hscale_config_reverb_damp->set_draw_value(true);
        hscale_config_reverb_damp->set_value_pos(GTK_POS_TOP);
        hscale_config_reverb_wet->set_flags(GTK_CAN_FOCUS);
        hscale_config_reverb_wet->set_digits(3);
        hscale_config_reverb_wet->set_draw_value(true);
        hscale_config_reverb_wet->set_value_pos(GTK_POS_TOP);
        hscale_config_reverb_dry->set_flags(GTK_CAN_FOCUS);
        hscale_config_reverb_dry->set_digits(3);
        hscale_config_reverb_dry->set_draw_value(true);
        hscale_config_reverb_dry->set_value_pos(GTK_POS_TOP);
        hscale_config_reverb_width->set_flags(GTK_CAN_FOCUS);
        hscale_config_reverb_width->set_digits(3);
        hscale_config_reverb_width->set_draw_value(true);
        hscale_config_reverb_width->set_value_pos(GTK_POS_TOP);
        table9->set_row_spacings(10);
        table9->set_col_spacings(0);
        table9->attach(*label55, 0, 1, 0, 1, GTK_FILL, 0, 0, 0);
        table9->attach(*label56, 0, 1, 1, 2, GTK_FILL, 0, 0, 0);
        table9->attach(*label57, 0, 1, 2, 3, GTK_FILL, 0, 0, 0);
        table9->attach(*label58, 0, 1, 3, 4, GTK_FILL, 0, 0, 0);
        table9->attach(*label59, 0, 1, 4, 5, GTK_FILL, 0, 0, 0);
        table9->attach(*hscale_config_reverb_room, 1, 2, 0, 1, GTK_EXPAND|GTK_FILL, GTK_FILL, 0, 0);
        table9->attach(*hscale_config_reverb_damp, 1, 2, 1, 2, GTK_FILL, GTK_FILL, 0, 0);
        table9->attach(*hscale_config_reverb_wet, 1, 2, 2, 3, GTK_FILL, GTK_FILL, 0, 0);
        table9->attach(*hscale_config_reverb_dry, 1, 2, 3, 4, GTK_FILL, GTK_FILL, 0, 0);
        table9->attach(*hscale_config_reverb_width, 1, 2, 4, 5, GTK_FILL, GTK_FILL, 0, 0);
        label33->set_alignment(0.5,0.5);
        label33->set_padding(0,0);
        label33->set_justify(GTK_JUSTIFY_CENTER);
        label33->set_line_wrap(false);
        label60->set_alignment(0,0.5);
        label60->set_padding(0,0);
        label60->set_justify(GTK_JUSTIFY_CENTER);
        label60->set_line_wrap(false);
        label61->set_alignment(0,0.5);
        label61->set_padding(0,0);
        label61->set_justify(GTK_JUSTIFY_CENTER);
        label61->set_line_wrap(false);
        label62->set_alignment(0,0.5);
        label62->set_padding(0,0);
        label62->set_justify(GTK_JUSTIFY_CENTER);
        label62->set_line_wrap(false);
        label63->set_alignment(0,0.5);
        label63->set_padding(0,0);
        label63->set_justify(GTK_JUSTIFY_CENTER);
        label63->set_line_wrap(false);
        label64->set_alignment(0,0.5);
        label64->set_padding(0,0);
        label64->set_justify(GTK_JUSTIFY_CENTER);
        label64->set_line_wrap(false);
        hscale6->set_flags(GTK_CAN_FOCUS);
        hscale6->set_digits(0);
        hscale6->set_draw_value(true);
        hscale6->set_value_pos(GTK_POS_TOP);
        hscale_config_chorus_speed->set_flags(GTK_CAN_FOCUS);
        hscale_config_chorus_speed->set_digits(1);
        hscale_config_chorus_speed->set_draw_value(true);
        hscale_config_chorus_speed->set_value_pos(GTK_POS_TOP);
        hscale_config_chorus_depth->set_flags(GTK_CAN_FOCUS);
        hscale_config_chorus_depth->set_digits(1);
        hscale_config_chorus_depth->set_draw_value(true);
        hscale_config_chorus_depth->set_value_pos(GTK_POS_TOP);
        hscale_config_chorus_feedback->set_flags(GTK_CAN_FOCUS);
        hscale_config_chorus_feedback->set_digits(0);
        hscale_config_chorus_feedback->set_draw_value(true);
        hscale_config_chorus_feedback->set_value_pos(GTK_POS_TOP);
        hscale_config_chorus_width->set_flags(GTK_CAN_FOCUS);
        hscale_config_chorus_width->set_digits(0);
        hscale_config_chorus_width->set_draw_value(true);
        hscale_config_chorus_width->set_value_pos(GTK_POS_TOP);
        table10->set_row_spacings(10);
        table10->set_col_spacings(0);
        table10->attach(*label60, 0, 1, 0, 1, GTK_FILL, 0, 0, 0);
        table10->attach(*label61, 0, 1, 1, 2, GTK_FILL, 0, 0, 0);
        table10->attach(*label62, 0, 1, 2, 3, GTK_FILL, 0, 0, 0);
        table10->attach(*label63, 0, 1, 3, 4, GTK_FILL, 0, 0, 0);
        table10->attach(*label64, 0, 1, 4, 5, GTK_FILL, 0, 0, 0);
        table10->attach(*hscale6, 1, 2, 0, 1, GTK_EXPAND|GTK_FILL, GTK_FILL, 0, 0);
        table10->attach(*hscale_config_chorus_speed, 1, 2, 1, 2, GTK_FILL, GTK_FILL, 0, 0);
        table10->attach(*hscale_config_chorus_depth, 1, 2, 2, 3, GTK_FILL, GTK_FILL, 0, 0);
        table10->attach(*hscale_config_chorus_feedback, 1, 2, 3, 4, GTK_FILL, GTK_FILL, 0, 0);
        table10->attach(*hscale_config_chorus_width, 1, 2, 4, 5, GTK_FILL, GTK_FILL, 0, 0);
        hscale_config_chorus_delay->set_alignment(0.5,0.5);
        hscale_config_chorus_delay->set_padding(0,0);
        hscale_config_chorus_delay->set_justify(GTK_JUSTIFY_CENTER);
        hscale_config_chorus_delay->set_line_wrap(false);
        notebook5->set_flags(GTK_CAN_FOCUS);
        notebook5->set_show_tabs(true);
        notebook5->set_show_border(true);
        notebook5->set_tab_pos(GTK_POS_TOP);
        notebook5->set_scrollable(false);
        notebook5->popup_disable();
        notebook5->pages().push_back(Gtk::Notebook_Helpers::TabElem(*table9, *label33));
        notebook5->pages().push_back(Gtk::Notebook_Helpers::TabElem(*table10, *hscale_config_chorus_delay));
        frame13->set_shadow_type(GTK_SHADOW_ETCHED_IN);
        frame13->set_label_align(0,0);
        frame13->add(*notebook5);
        hbox4->pack_start(*frame12);
        hbox4->pack_start(*frame13);
        clist_config_synth_engine_list->set_flags(GTK_CAN_FOCUS);
        clist_config_synth_engine_list->set_column_title(0, "Driver");
        clist_config_synth_engine_list->set_column_justification(0, GTK_JUSTIFY_CENTER);
        clist_config_synth_engine_list->set_column_width(0, 80);
        clist_config_synth_engine_list->set_selection_mode(GTK_SELECTION_SINGLE);
        clist_config_synth_engine_list->column_titles_show();
        scrolledwindow4->set_usize(167,-1);
        scrolledwindow4->set_policy(GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
        scrolledwindow4->add(*clist_config_synth_engine_list);
        frame_output_synth_engine_properties_container->set_shadow_type(GTK_SHADOW_ETCHED_IN);
        frame_output_synth_engine_properties_container->set_label_align(0,0);
        hbox7->pack_start(*scrolledwindow4, false, true, 0);
        hbox7->pack_start(*frame_output_synth_engine_properties_container);
        frame17->set_shadow_type(GTK_SHADOW_ETCHED_IN);
        frame17->set_label_align(0,0);
        frame17->add(*hbox7);
        label67->set_alignment(0,0.5);
        label67->set_padding(0,0);
        label67->set_justify(GTK_JUSTIFY_CENTER);
        label67->set_line_wrap(false);
        spinbutton_config_gui_refresh_rate->set_flags(GTK_CAN_FOCUS);
        spinbutton_config_gui_refresh_rate->set_update_policy(GTK_UPDATE_ALWAYS);
        spinbutton_config_gui_refresh_rate->set_numeric(false);
        spinbutton_config_gui_refresh_rate->set_digits(0);
        spinbutton_config_gui_refresh_rate->set_wrap(false);
        spinbutton_config_gui_refresh_rate->set_snap_to_ticks(false);
        table12->set_row_spacings(0);
        table12->set_col_spacings(0);
        table12->attach(*label67, 0, 1, 0, 1, GTK_FILL, 0, 0, 0);
        table12->attach(*spinbutton_config_gui_refresh_rate, 1, 2, 0, 1, GTK_FILL, 0, 0, 0);
        table12->attach(*label_config_preamp, 0, 1, 1, 2, GTK_FILL, 0, 0, 0);
        table12->attach(*scale_config_preamp, 1, 2, 1, 2, GTK_FILL|GTK_EXPAND, 0, 0, 0);
        table12->attach(*label_config_drums_channel, 0, 1, 2, 3, GTK_FILL, 0, 0, 0);
        table12->attach(*spinbutton_config_drums_channel, 1, 2, 2, 3, GTK_FILL, 0, 0, 0);
        
        frame19->set_shadow_type(GTK_SHADOW_ETCHED_IN);
        frame19->set_label_align(0,0);
        frame19->add(*table12);
        hbox6->pack_start(*frame17);
        hbox6->pack_start(*frame19);
        vbox4->pack_start(*hbox4, false, true, 0);
        vbox4->pack_start(*hbox6);
        label3->set_alignment(0.5,0.5);
        label3->set_padding(0,0);
        label3->set_justify(GTK_JUSTIFY_CENTER);
        label3->set_line_wrap(false);
        notebook1->set_flags(GTK_CAN_FOCUS);
        notebook1->set_show_tabs(true);
        notebook1->set_show_border(true);
        notebook1->set_tab_pos(GTK_POS_TOP);
        notebook1->set_scrollable(false);
        notebook1->popup_disable();
        notebook1->pages().push_back(Gtk::Notebook_Helpers::TabElem(*vbox6, *label34));
        notebook1->pages().push_back(Gtk::Notebook_Helpers::TabElem(*hbox1, *label1));
        notebook1->pages().push_back(Gtk::Notebook_Helpers::TabElem(*vbox3, *label2));
        notebook1->pages().push_back(Gtk::Notebook_Helpers::TabElem(*vbox4, *label3));
        set_title((string)"LegaSynth v."+(string)VERSION+" (c) 2002 Juan Linietsky");
        set_modal(false);
        set_position(GTK_WIN_POS_NONE);
        add(*notebook1);
        table7->show();
        frame15->show();
        label35->show();
        label36->show();
        label37->show();
        label38->show();
        label39->show();
        label40->show();
        entry_info_chan_1->show();
        label41->show();
        vseparator1->show();
        label42->show();
        label43->show();
        entry_info_chan_2->show();
        entry_info_chan_3->show();
        entry_info_chan_4->show();
        entry_info_chan_5->show();
        entry_infp_chan_6->show();
        entry_info_chan_7->show();
        entry_info_chan_8->show();
        label44->show();
        label45->show();
        label46->show();
        label47->show();
        label48->show();
        label49->show();
        label50->show();
        label51->show();
        entry_info_voices->show();
        label52->show();
        entry_info_events->show();
        label53->show();
        label54->show();
        entry_info_latency->show();
        entry_info_cpu->show();
        entry_info_chan_10->show();
        entry_info_chan_9->show();
        entry_info_chan_11->show();
        entry_info_chan_12->show();
        entry_info_chan_13->show();
        entry_info_chan_14->show();
        entry_info_chan_15->show();
        entry_info_chan16->show();
        table8->show();
        frame14->show();
        vbox6->show();
        label34->show();
        clist_device_banks->show();
        scrolledwindow1->show();
        radiobutton_device_bank_type_instrument->show();
        radiobutton_device_bank_type_drum->show();
        hbox2->show();
//        frame2->show();
        label8->show();
        entry_device_bank_engine->show();
        label9->show();
        entry_device_bank_name->show();
        table2->show();
        frame4->show();
        frame3->show();
        label10->show();
        hseparator1->show();
        button_bank_copy->show();
        button_bank_paste->show();
        button_bank_moveup->show();
        button_bank_movedown->show();
        label11->show();
        hseparator2->show();
        button_bank_load->show();
        button_bank_save->show();
        button_bank_delete->show();
        optionmenu_bank_engine->show();
        hseparator3->show();
        button_bank_new->show();
        hseparator4->show();
        table3->show();
        frame5->show();
        label65->show();
        button_device_new->show();
        button_device_load->show();
        button_device_save->show();
        hseparator7->show();
        entry_device_file_name->show();
        button_device_browse->show();
        table11->show();
//        frame16->show();
        vbox1->show();
        frame1->show();
        hbox1->show();
        label1->show();
        clist_bank_patch->show();
        scrolledwindow2->show();
        frame6->show();
        button_bank_patch_copy->show();
        button_bank_patch_paste->show();
        button_bank_patch_moveup->show();
        button_bank_patch_movdwon->show();
        label20->show();
        label21->show();
        label22->show();
        entry_bank_type->show();
        entry_bank_patch_name->show();
        spinbutton_bank_number->show();
        table4->show();
        vbox3->show();
        vbox3b->show();
        hbox3->show();
        vbox2->show();
        label20b->show();
        fram_bank_patchconfig_container->show();
        frame8->show();
        label21b->show();
        notebook4->show();
        drawingarea_bank_patch_waveform->show();
        frame11->show();
        frame10->show();
        label69->show();
        hscale_bank_patch_zoom->show();
        hbox8->show();
        vbox3->show();
        label2->show();
        checkbutton_config_output_16bits->show();
        checkbutton_config_output_stereo->show();
        radiobutton_config_output_enabled->show();
        radiobutton_config_output_disabled->show();
        label28->show();
        optionmenu_config_output_frequency->show();
        clist_config_audio_driver_list->show();
        scrolledwindow3->show();
        hseparator5->show();
        hseparator6->show();
        label29->show();
        label30->show();
        entry_output_log_file_name->show();
        button_config_output_log_file_name_browse->show();
        table5->show();
        frame12->show();
        label55->show();
        label56->show();
        label57->show();
        label58->show();
        label59->show();
        hscale_config_reverb_room->show();
        hscale_config_reverb_damp->show();
        hscale_config_reverb_wet->show();
        hscale_config_reverb_dry->show();
        hscale_config_reverb_width->show();
        table9->show();
        label33->show();
        label60->show();
        label61->show();
        label62->show();
        label63->show();
        label64->show();
        hscale6->show();
        hscale_config_chorus_speed->show();
        hscale_config_chorus_depth->show();
        hscale_config_chorus_feedback->show();
        hscale_config_chorus_width->show();
        table10->show();
        hscale_config_chorus_delay->show();
        notebook5->show();
        frame13->show();
        hbox4->show();
        clist_config_synth_engine_list->show();
        scrolledwindow4->show();
        frame_output_synth_engine_properties_container->show();
        hbox7->show();
        frame17->show();
        label67->show();
        spinbutton_config_gui_refresh_rate->show();
        table12->show();
        frame19->show();
        hbox6->show();
        vbox4->show();
        label3->show();
        notebook1->show();
        frame11->add(voice_preview);
        voice_preview.set_usize(-1,60);


        clist_device_banks->select_row.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_clist_device_banks_select_row));
        radiobutton_device_bank_type_instrument->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_radiobutton_device_bank_type_instrument_clicked));
        radiobutton_device_bank_type_drum->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_radiobutton_device_bank_type_drum_clicked));
        entry_device_bank_name->changed.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_entry_device_bank_name_changed));
        button_bank_copy->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_button_bank_copy_clicked));
        button_bank_paste->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_button_bank_paste_clicked));
        button_bank_moveup->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_button_bank_moveup_clicked));
        button_bank_movedown->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_button_bank_movedown_clicked));
        button_bank_load->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_button_bank_load_clicked));
        button_bank_save->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_button_bank_save_clicked));
        button_bank_delete->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_button_bank_delete_clicked));
        button_bank_new->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_button_bank_new_clicked));
        button_device_new->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_button_device_new_clicked));
        button_device_load->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_button_device_load_clicked));
        button_device_save->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_button_device_save_clicked));
        button_device_browse->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_button_device_browse_clicked));
        clist_bank_patch->select_row.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_clist_bank_patch_select_row));
        button_bank_patch_copy->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_button_bank_patch_copy_clicked));
        button_bank_patch_paste->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_button_bank_patch_paste_clicked));
        button_bank_patch_moveup->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_button_bank_patch_moveup_clicked));
        button_bank_patch_movdwon->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_button_bank_patch_movdwon_clicked));
        entry_bank_patch_name->changed.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_entry_bank_patch_name_changed));
        spinbutton_bank_number->changed.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_spinbutton_bank_number_changed));
        checkbutton_config_output_16bits->toggled.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_checkbutton_config_output_16bits_toggled));
        checkbutton_config_output_stereo->toggled.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_checkbutton_config_output_stereo_toggled));
        radiobutton_config_output_enabled->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_radiobutton_config_output_enabled_clicked));
        radiobutton_config_output_enabled->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_radiobutton_config_output_enabled_clicked));
        radiobutton_config_output_disabled->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_radiobutton_config_output_disabled_toggled));
        radiobutton_config_output_disabled->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_radiobutton_config_output_disabled_clicked));
        clist_config_audio_driver_list->select_row.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_clist_config_audio_driver_list_select_row));
        button_config_output_log_file_name_browse->clicked.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_button_config_output_log_file_name_browse_clicked));
        clist_config_synth_engine_list->select_row.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_clist_config_synth_engine_list_select_row));
        spinbutton_config_gui_refresh_rate->changed.connect(SigC::slot(static_cast<class Interface*>(this), &Interface::on_spinbutton_config_gui_refresh_rate_changed));
        dynamic_config.changed.connect(SigC::slot(this,&Interface::draw_voice_preview));

        clist_device_banks->set_column_justification(1,GTK_JUSTIFY_LEFT);
        clist_device_banks->set_column_justification(2,GTK_JUSTIFY_LEFT);
        clist_device_banks->set_column_justification(3,GTK_JUSTIFY_LEFT);
        clist_bank_patch->set_column_justification(1,GTK_JUSTIFY_LEFT);
        clist_bank_patch->set_column_justification(2,GTK_JUSTIFY_LEFT);
        clist_bank_patch->set_column_justification(3,GTK_JUSTIFY_LEFT);

    	for (int i=0;i<128;i++) {

             	vector<string> stringlist;
              	stringlist.push_back(itostr(i+1));
              	stringlist.push_back("-");
              	stringlist.push_back("?");
              	stringlist.push_back("");
		clist_bank_patch->append(stringlist);

     	}

	entry_info_array[0]=entry_info_chan_1;
	entry_info_array[1]=entry_info_chan_2;
	entry_info_array[2]=entry_info_chan_3;
	entry_info_array[3]=entry_info_chan_4;
	entry_info_array[4]=entry_info_chan_5;
	entry_info_array[5]=entry_infp_chan_6;
	entry_info_array[6]=entry_info_chan_7;
	entry_info_array[7]=entry_info_chan_8;
	entry_info_array[8]=entry_info_chan_9;
	entry_info_array[9]=entry_info_chan_10;
	entry_info_array[10]=entry_info_chan_11;
	entry_info_array[11]=entry_info_chan_12;
	entry_info_array[12]=entry_info_chan_13;
	entry_info_array[13]=entry_info_chan_14;
	entry_info_array[14]=entry_info_chan_15;
	entry_info_array[15]=entry_info_chan16;

	for(int i=0;i<16;i++) {

         	int x=i%4;
         	int y=i/4;

        	table7->attach(voice_show[i],x,x+1,y,y+1,GTK_FILL|GTK_EXPAND,GTK_FILL|GTK_EXPAND,0,0);
		voice_show[i].show();
 	}

        selected_patch=0;
        selected.drum=-1;
        selected.bank=-1;
        updating_bank=false;
        updating_patch=false;
        updating_config=false;
        updating_devices=false;

        quit_requested=false;

        set_usize(700,500);
        set_position(GTK_WIN_POS_CENTER);
	show();
}

Bank * Interface::bank() {

	Bank *aux = dev_manager->get_bank(selected.bank);
	if (aux==NULL) return NULL;
	if (selected.drum==-1) return aux;

	return aux->get_drums(selected.drum);

}


void Interface::set_device_manager(Device_Manager *p_devmanager) {

   	dev_manager=p_devmanager;

    	for (int i=0;i<dev_manager->get_device_count();i++) {

        	optionmenu_bank_engine->add_option(dev_manager->get_device(i)->get_name());
     	}

	interface_update_device();

}



Interface::~Interface(){
}
