/***************************************************************************
                          interface.h  -  description
                             -------------------
    begin                : Fri Jul 5 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INTERFACE_H
#define INTERFACE_H

#include <gtk--/table.h>
#include <gtk--/frame.h>
#include <gtk--/label.h>
#include <gtk--/entry.h>
#include <gtk--/separator.h>
#include <gtk--/box.h>
#include <gtk--/clist.h>
#include <gtk--/scrolledwindow.h>
#include <gtk--/radiobutton.h>
#include <gtk--/button.h>
#include <gtk--/combo.h>
#include <gtk--/menu.h>
#include <gtk--/menuitem.h>
#include <gtk--/optionmenu.h>
#include <gtk--/spinbutton.h>
#include <gtk--/adjustment.h>
#include <gtk--/notebook.h>
#include <gtk--/drawingarea.h>
#include <gtk--/scale.h>
#include <gtk--/checkbutton.h>
#include <gtk--/window.h>
#include <gtk--/tree.h>


#include "device_manager.h"
#include "interface_widget_optionselect.h"
#include "interface_widget_dynamic_config.h"
#include "interface_widget_voice_show.h"
#include "interface_widget_voice_preview.h"

#include "file_select_widget.h"
#include "sound_driver_manager.h"

#include "mutex_lock.h"
#include "mixer.h"
#include "midi_event.h"


/**
  *@author red
  */

class Interface : public Gtk::Window {

	static const char* Interface::notes[128];

   Gtk::Tree bank_tree;
   Gtk::Table *table7;
   Gtk::Frame *frame15;
   Gtk::Label *label35;
   Gtk::Label *label36;
   Gtk::Label *label37;
   Gtk::Label *label38;
   Gtk::Label *label39;
   Gtk::Label *label40;
   Gtk::Entry *entry_info_chan_1;
   Gtk::Label *label41;
   Gtk::VSeparator *vseparator1;
   Gtk::Label *label42;
   Gtk::Label *label43;
   Gtk::Entry *entry_info_chan_2;
   Gtk::Entry *entry_info_chan_3;
   Gtk::Entry *entry_info_chan_4;
   Gtk::Entry *entry_info_chan_5;
   Gtk::Entry *entry_infp_chan_6;
   Gtk::Entry *entry_info_chan_7;
   Gtk::Entry *entry_info_chan_8;
	Gtk::Entry *entry_info_array[16];

   Gtk::Label *label_config_preamp;
   Gtk::Adjustment *scale_config_preamp_adj;
   Gtk::HScale *scale_config_preamp;

   Gtk::Label *label_config_drums_channel;
   Gtk::Adjustment *spinbutton_config_drums_channel_adj;
   Gtk::SpinButton *spinbutton_config_drums_channel;
		
   Gtk::Label *label44;
   Gtk::Button *button_device_add_drum;
   Gtk::Button *button_device_delete_drum;
   Gtk::Label *label45;
   Gtk::Label *label46;
   Gtk::Label *label47;
   Gtk::Label *label48;
   Gtk::Label *label49;
   Gtk::Label *label50;
   Gtk::Label *label51;
   Gtk::Entry *entry_info_voices;
   Gtk::Label *label52;
   Gtk::Entry *entry_info_events;
   Gtk::Label *label53;
   Gtk::Label *label54;
   Gtk::Entry *entry_info_latency;
   Gtk::Entry *entry_info_cpu;
   Gtk::Entry *entry_info_chan_10;
   Gtk::Entry *entry_info_chan_9;
   Gtk::Entry *entry_info_chan_11;
   Gtk::Entry *entry_info_chan_12;
   Gtk::Entry *entry_info_chan_13;
   Gtk::Entry *entry_info_chan_14;
   Gtk::Entry *entry_info_chan_15;
   Gtk::Entry *entry_info_chan16;
   Gtk::Table *table8;
   Gtk::Frame *frame14;
   Gtk::VBox *vbox6;
   Gtk::Label *label34;
   Gtk::CList *clist_device_banks;
   Gtk::ScrolledWindow *scrolledwindow1;
   Gtk::RadioButton::Group _RadioBGroup_;
   Gtk::RadioButton *radiobutton_device_bank_type_instrument;
   Gtk::RadioButton *radiobutton_device_bank_type_drum;
   Gtk::HBox *hbox2;
   Gtk::Frame *frame2;
   Gtk::Label *label8;
   Gtk::Entry *entry_device_bank_engine;
   Gtk::Label *label9;
   Gtk::Entry *entry_device_bank_name;
   Gtk::Table *table2;
   Gtk::Frame *frame4;
   Gtk::Frame *frame3;
   Gtk::Label *label10;
   Gtk::HSeparator *hseparator1;
   Gtk::Button *button_bank_copy;
   Gtk::Button *button_bank_paste;
   Gtk::Button *button_bank_moveup;
   Gtk::Button *button_bank_movedown;
   Gtk::Label *label11;
   Gtk::HSeparator *hseparator2;
   Gtk::Button *button_bank_load;
   Gtk::Button *button_bank_save;
   Gtk::Button *button_bank_delete;
   Interface_Widget_OptionSelect *optionmenu_bank_engine;
   Gtk::HSeparator *hseparator3;
   Gtk::Button *button_bank_new;
   Gtk::HSeparator *hseparator4;
   Gtk::Table *table3;
   Gtk::Frame *frame5;
   Gtk::Label *label65;
   Gtk::Button *button_device_new;
   Gtk::Button *button_device_load;
   Gtk::Button *button_device_save;
   Gtk::HSeparator *hseparator7;
   Gtk::Entry *entry_device_file_name;
   Gtk::Button *button_device_browse;
   Gtk::Table *table11;
   Gtk::Frame *frame16;
   Gtk::VBox *vbox1;
   Gtk::Frame *frame1;
   Gtk::HBox *hbox1;
   Gtk::Label *label1;
   Gtk::CList *clist_bank_patch;
   Gtk::ScrolledWindow *scrolledwindow2;
   Gtk::Frame *frame6;
   Gtk::Button *button_bank_patch_copy;
   Gtk::Button *button_bank_patch_paste;
   Gtk::Button *button_bank_patch_moveup;
   Gtk::Button *button_bank_patch_movdwon;
   Gtk::Label *label20b;
   Gtk::Label *label21;
   Gtk::Label *label22;
   Gtk::Entry *entry_bank_type;
   Gtk::Entry *entry_bank_patch_name;
   Gtk::Adjustment *spinbutton_bank_number_adj;
   Gtk::SpinButton *spinbutton_bank_number;
   Gtk::Table *table4;
   Gtk::VBox *vbox3;
   Gtk::VBox *vbox3b;
   Gtk::HBox *hbox3;
   Gtk::VBox *vbox2;
   Gtk::Label *label20;
   Gtk::Frame *fram_bank_patchconfig_container;
   Gtk::Frame *frame8;
   Gtk::Label *label21b;
   Gtk::Notebook *notebook4;
   Gtk::DrawingArea *drawingarea_bank_patch_waveform;
   Gtk::Frame *frame11;
   Gtk::Frame *frame10;
   Gtk::Label *label69;
   Gtk::Adjustment *hscale_bank_patch_zoom_adj;
   Gtk::HScale *hscale_bank_patch_zoom;
   Gtk::HBox *hbox8;
//   Gtk::VBox *vbox3;
   Gtk::Label *label2;
   Gtk::CheckButton *checkbutton_config_output_16bits;
   Gtk::CheckButton *checkbutton_config_output_stereo;
   Gtk::RadioButton *radiobutton_config_output_enabled;
   Gtk::RadioButton *radiobutton_config_output_disabled;
   Gtk::Label *label28;
   Gtk::Combo *optionmenu_config_output_frequency;
   Gtk::Combo *combo_config_buffersize;
   Gtk::Label *label_config_buffersize;
   Gtk::CList *clist_config_audio_driver_list;
   Gtk::ScrolledWindow *scrolledwindow3;
   Gtk::HSeparator *hseparator5;
   Gtk::HSeparator *hseparator6;
   Gtk::Label *label29;
   Gtk::Label *label30;
   Gtk::Entry *entry_output_log_file_name;
   Gtk::Button *button_config_output_log_file_name_browse;
   Gtk::Table *table5;
   Gtk::Frame *frame12;
   Gtk::Label *label55;
   Gtk::Label *label56;
   Gtk::Label *label57;
   Gtk::Label *label58;
   Gtk::Label *label59;
   Gtk::Adjustment *hscale_config_reverb_room_adj;
   Gtk::HScale *hscale_config_reverb_room;
   Gtk::Adjustment *hscale_config_reverb_damp_adj;
   Gtk::HScale *hscale_config_reverb_damp;
   Gtk::Adjustment *hscale_config_reverb_wet_adj;
   Gtk::HScale *hscale_config_reverb_wet;
   Gtk::Adjustment *hscale_config_reverb_dry_adj;
   Gtk::HScale *hscale_config_reverb_dry;
   Gtk::Adjustment *hscale_config_reverb_width_adj;
   Gtk::HScale *hscale_config_reverb_width;
   Gtk::Table *table9;
   Gtk::Label *label33;
   Gtk::Label *label60;
   Gtk::Label *label61;
   Gtk::Label *label62;
   Gtk::Label *label63;
   Gtk::Label *label64;
   Gtk::Adjustment *hscale6_adj;
   Gtk::HScale *hscale6;
   Gtk::Adjustment *hscale_config_chorus_speed_adj;
   Gtk::HScale *hscale_config_chorus_speed;
   Gtk::Adjustment *hscale_config_chorus_depth_adj;
   Gtk::HScale *hscale_config_chorus_depth;
   Gtk::Adjustment *hscale_config_chorus_feedback_adj;
   Gtk::HScale *hscale_config_chorus_feedback;
   Gtk::Adjustment *hscale_config_chorus_width_adj;
   Gtk::HScale *hscale_config_chorus_width;
   Gtk::Table *table10;
   Gtk::Label *hscale_config_chorus_delay;
   Gtk::Notebook *notebook5;
   Gtk::Frame *frame13;
   Gtk::HBox *hbox4;
   Gtk::CList *clist_config_synth_engine_list;
   Gtk::ScrolledWindow *scrolledwindow4;
   Gtk::Frame *frame_output_synth_engine_properties_container;
   Gtk::HBox *hbox7;
   Gtk::Frame *frame17;
   Gtk::Label *label67;
   Gtk::Adjustment *spinbutton_config_gui_refresh_rate_adj;
   Gtk::SpinButton *spinbutton_config_gui_refresh_rate;
   Gtk::Table *table12;
   Gtk::Frame *frame19;
   Gtk::HBox *hbox6;
   Gtk::VBox *vbox4;
   Gtk::Label *label3;
   Gtk::Notebook *notebook1;
   Interface_Widget_Dynamic_Config dynamic_config;
	Device_Manager *dev_manager;
   Interface_Widget_Voice_Show voice_show[16];
	Interface_Widget_Voice_Preview voice_preview;

	void on_clist_device_banks_select_row(gint row, gint column, GdkEvent *event);
        void on_radiobutton_device_bank_type_instrument_clicked();
        void on_radiobutton_device_bank_type_drum_clicked();
        void on_entry_device_bank_name_changed();
        void on_button_bank_copy_clicked();
        void on_button_bank_paste_clicked();
        void on_button_bank_moveup_clicked();
        void on_button_bank_movedown_clicked();
        void on_button_bank_load_clicked();
        void on_button_bank_save_clicked();
        void on_button_bank_delete_clicked();
        void on_button_bank_new_clicked();
        void on_button_device_new_clicked();
        void on_button_device_load_clicked();
        void on_button_device_save_clicked();
        void on_button_device_browse_clicked();
        void on_clist_bank_patch_select_row(gint row, gint column, GdkEvent *event);
        void on_button_bank_patch_copy_clicked();
        void on_button_bank_patch_paste_clicked();
        void on_button_bank_patch_moveup_clicked();
        void on_button_bank_patch_movdwon_clicked();
        void on_entry_bank_patch_name_changed();
        void on_spinbutton_bank_number_changed();
        void on_checkbutton_config_output_16bits_toggled();
        void on_checkbutton_config_output_stereo_toggled();
        void on_radiobutton_config_output_enabled_clicked();
        void on_radiobutton_config_output_disabled_toggled();
        void on_radiobutton_config_output_disabled_clicked();
        void on_clist_config_audio_driver_list_select_row(gint row, gint column, GdkEvent *event);
        void on_button_config_output_log_file_name_browse_clicked();
        void on_clist_config_synth_engine_list_select_row(gint row, gint column, GdkEvent *event);
        void on_spinbutton_config_gui_refresh_rate_changed();
        void on_reverb_parameters_changed();
        void on_chorus_parameters_changed();
        void on_patch_zoom_changed();
	void on_tree_item_select(int p_bank,int p_drum);
	void on_drum_add();
	void on_drum_delete();
        void on_optionmenu_config_output_frequency_changed();
        void on_combo_config_buffersize_changed();
	void on_scale_config_preamp_changed();
	void on_spinbutton_config_drums_channel_changed();
	
        Bank * bank();

	struct Selected {

		int bank;
		int drum;
	} selected;
	                                        	      
       // int selected_bank;
        bool updating_bank;
        int selected_patch;
        bool updating_patch;
        bool updating_config;
        bool updating_devices;

        bool quit_requested;

        void draw_voice_preview();


        struct DisplayCache {

                int counter;

                int active_voices,event_count;

                string instrument[16];

		DisplayCache() {

   			counter=event_count=active_voices=0;
          	}
        } display_cache;


	struct GtkSucksItem {

		Gtk::TreeItem ti;
		Gtk::Tree drums_subtree;                     												

		GtkSucksItem(string p_name) : ti (p_name) { ti.show(); };
	//	~GtkSucksItem() { for (int i=0;i<drums.size();i++) delete drums[i]; };
		
		struct GtkSucksEvenMoreItem {

			Gtk::TreeItem ti;

			GtkSucksEvenMoreItem(string p_name) : ti(p_name) { ti.show(); }
		private:

			
			GtkSucksEvenMoreItem() {};
		
		};

		vector<GtkSucksEvenMoreItem*> drums;

		private:
		GtkSucksItem();
	};

	vector<GtkSucksItem*> bank_tree_crap;

public:

	Mutex_Lock *mutex;
        Mixer * mixer;
        Midi_Event *midi_event;
        Sound_Driver_Manager *driver_manager;

       	gint delete_event_impl(GdkEventAny* p_event) {

                quit_requested=true;
		return 1;
	}

	bool is_quit_requested() { return quit_requested; }
	Gtk::Main *kit;
        void interface_update_device();
        void interface_update_bank();
        void interface_update_patch();
        void interface_update_config();

	void update_info_widgets();

	void set_device_manager(Device_Manager *p_devmanager);

	Interface();
	~Interface();
};

#endif
