/***************************************************************************
                          interface_callbacks_bank.cpp  -  description
                             -------------------
    begin                : Sat Jul 6 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "interface.h"


void Interface::on_clist_bank_patch_select_row(gint row, gint column, GdkEvent *event) {

	selected_patch=row;
 	interface_update_patch();
}

void Interface::on_button_bank_patch_copy_clicked()
{
	dev_manager->copy_patch(selected.bank,selected.drum,selected_patch);

}
void Interface::on_patch_zoom_changed() {

	voice_preview.set_zoom(hscale_bank_patch_zoom_adj->get_value());
}
void Interface::on_button_bank_patch_paste_clicked()
{
        mutex->grab();
	dev_manager->paste_patch(selected.bank,selected.drum,selected_patch);
        mutex->release();

 	interface_update_bank();

}

void Interface::on_button_bank_patch_moveup_clicked()
{
	FileSelectWidget fileselect;

 	fileselect.set_mode(FileSelectWidget::LOAD);
  	fileselect.poll_until_action(*kit);

   	if (fileselect.get_action()==FileSelectWidget::OK) {

            	bool recognized=false;
                for (int i=0;i<dev_manager->get_device_count();i++) {

			if (dev_manager->get_device(i)->recognize_patch(fileselect.get_filename())) {

     				bank()->load_patch(fileselect.get_filename(),selected_patch);

				interface_update_device();
    				recognized=true;
           		}
             	}


		if (!recognized) {

	           	vector<Uint8> patchdata;
	           	load_vector_from_file(fileselect.get_filename(),patchdata);
	            	int size=get_int_from_vector(&patchdata[0]);
	             	bank()->set_patch_data_vector(selected_patch,&patchdata[4],size);
		}
    	}	

	interface_update_bank();     	
}

void Interface::on_button_bank_patch_movdwon_clicked()
{

	FileSelectWidget fileselect;

 	fileselect.set_mode(FileSelectWidget::SAVE);
  	fileselect.poll_until_action(*kit);

   	if (fileselect.get_action()==FileSelectWidget::OK) {


          	vector<Uint8> patchdata;
           	bank()->get_patch_data_vector(selected_patch,patchdata);
		save_vector_to_file(fileselect.get_filename(),patchdata);
    
    	}	
}

void Interface::on_entry_bank_patch_name_changed()
{
	if (updating_patch) return;

	bank()->set_patch_name(selected_patch,entry_bank_patch_name->get_text());
 	clist_bank_patch->set_text(selected_patch,3,entry_bank_patch_name->get_text());

}

void Interface::on_spinbutton_bank_number_changed()
{
	if (updating_bank) return;

	bank()->set_drum_note(selected_patch,spinbutton_bank_number->get_value_as_int());
	clist_bank_patch->set_text(selected_patch,3,notes[bank()->get_drum_note(selected_patch)]);
	
//	selected_bank=spinbutton_bank_number->get_value_as_int();
	interface_update_bank();
}