/***************************************************************************
                          interface_callbacks_device.cpp  -  description
                             -------------------
    begin                : Sat Jul 6 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "interface.h"


void Interface::on_tree_item_select(int p_bank,int p_drum) {

	if (updating_devices) return;

	printf("p_bank %i, p_drum %i\n",p_bank,p_drum);
	selected.bank=p_bank;
	selected.drum=p_drum;
	interface_update_bank();
		
}


void Interface::on_clist_device_banks_select_row(gint row, gint column, GdkEvent *event)
{

	if (updating_bank) return;

	selected.bank=row;
	interface_update_bank();
}

void Interface::on_radiobutton_device_bank_type_instrument_clicked()
{

	if (updating_bank) return;
	mutex->grab();
	bank()->set_type(Bank::INSTRUMENT);
	mutex->release();

 	clist_device_banks->set_text(selected.bank,2,"Instr.");
 	
}

void Interface::on_radiobutton_device_bank_type_drum_clicked() {


	if (updating_bank) return;
	mutex->grab();
	bank()->set_type(Bank::DRUM);
	mutex->release();
 	clist_device_banks->set_text(selected.bank,2,"Drum");

}

void Interface::on_entry_device_bank_name_changed()
{
       	char numb[4];
  	string bankstring;
     	numb[3]=0;
	
  
	if (updating_bank) return;

 	bank()->set_name(entry_device_bank_name->get_text());
 	//clist_device_banks->set_text(selected.bank,3,entry_device_bank_name->get_text());
  	if (selected.drum==-1) {

   		int i=selected.bank;

	    	numb[0]='0'+i/100;
	    	numb[1]='0'+(i/10)%10;
	    	numb[2]='0'+i%10;

   		Gtk::Label *label;
     		bankstring=(string)numb+(string)"-"+bank()->get_model_name()+(string)"  "+bank()->get_name();
	  	label=(Gtk::Label*)bank_tree_crap[selected.bank]->ti.get_child();
	   	label->set(bankstring);
   	} else {

   		int j=selected.drum;
     
		numb[0]='0'+j/100;
		numb[1]='0'+(j/10)%10;
		numb[2]='0'+j%10;
	
		bankstring=(string)numb+(string)"-DRUMS "+bank()->get_name();
   		Gtk::Label *label;
	  	label=(Gtk::Label*)bank_tree_crap[selected.bank]->drums[selected.drum]->ti.get_child();
	   	label->set(bankstring);
	

    	}

  

}

void Interface::on_button_bank_copy_clicked()
{
	if (!dev_manager->get_bank_count()) return;


	dev_manager->copy_bank(selected.bank);

}

void Interface::on_button_bank_paste_clicked()
{

	mutex->grab();
	dev_manager->paste_bank(selected.bank);
	mutex->release();
 	interface_update_device();
}

void Interface::on_button_bank_moveup_clicked()
{
	if (!dev_manager->get_bank_count()) return;

	if (selected.bank==0) return;
	mutex->grab();
 	dev_manager->bank_moveup(selected.bank);
	mutex->release();

  	selected.bank--;
   	interface_update_device();

}

void Interface::on_drum_add() {
        if (bank()==NULL) return;
	mutex->grab();
	dev_manager->get_bank(selected.bank)->add_drums();
	mutex->release();
   	interface_update_device();
	
}
void Interface::on_drum_delete() {

        if (bank()==NULL) return;
	mutex->grab();
	dev_manager->get_bank(selected.bank)->delete_drums(selected.drum);
	mutex->release();
	selected.drum=-1;
   	interface_update_device();
    
	

}

void Interface::on_button_bank_movedown_clicked()
{
	if (!dev_manager->get_bank_count()) return;

	if (selected.bank==(dev_manager->get_bank_count()-1)) return;

 	mutex->grab();
   	dev_manager->bank_movedown(selected.bank);
	mutex->release();
	

	selected.bank++;

   	interface_update_device();

}

void Interface::on_button_bank_load_clicked(){

	FileSelectWidget fileselect;

 	fileselect.set_mode(FileSelectWidget::LOAD);
  	fileselect.poll_until_action(*kit);

   	if (fileselect.get_action()==FileSelectWidget::OK) {

            	bool recognized=false;
                for (int i=0;i<dev_manager->get_device_count();i++) {

			if (dev_manager->get_device(i)->recognize_bank(fileselect.get_filename())) {
 	
  				mutex->grab();
  				dev_manager->add_bank(i);
				mutex->release();

			 	selected.bank=dev_manager->get_bank_count()-1;
			  	selected.drum=-1;
//     				bank()->load_file(fileselect.get_filename());
        		   	dev_manager->get_bank(selected.bank)->load_file(fileselect.get_filename());        

				interface_update_device();
    				recognized=true;
           		}
             	} 	


              	if (!recognized) { //generic load
			mutex->grab();
	           	dev_manager->load_bank(fileselect.get_filename());
			mutex->release();
		 	selected.bank=dev_manager->get_bank_count()-1;
		  	selected.drum=-1;		  
               		interface_update_device();
		}
      	}	
}

void Interface::on_button_bank_save_clicked()
{

	if (!dev_manager->get_bank_count()) return;

	FileSelectWidget fileselect;

 	fileselect.set_mode(FileSelectWidget::SAVE);
  	fileselect.poll_until_action(*kit);

   	if (fileselect.get_action()==FileSelectWidget::OK) {

 	
          	vector<Uint8> bankdata;
           	dev_manager->get_bank(selected.bank)->get_bank_data_vector(bankdata);
		save_vector_to_file(fileselect.get_filename(),bankdata);
    	}	

}

void Interface::on_button_bank_delete_clicked() {

	if (!dev_manager->get_bank_count()) return;

	mutex->grab();
 	dev_manager->bank_delete(selected.bank);
	mutex->release();

  	if (selected.bank>=dev_manager->get_bank_count()) {
   
   		selected.bank=dev_manager->get_bank_count()-1;
	  	selected.drum=-1;
	}	

	interface_update_device();

}

void Interface::on_button_bank_new_clicked()
{
	mutex->grab();
 	dev_manager->add_bank(optionmenu_bank_engine->get_option_selected());	
	mutex->release();

 	selected.bank=dev_manager->get_bank_count()-1;
  	selected.drum=-1;
	interface_update_device();

}

void Interface::on_button_device_new_clicked()
{
}

void Interface::on_button_device_load_clicked()
{
}

void Interface::on_button_device_save_clicked()
{
}

void Interface::on_button_device_browse_clicked()
{
}