/***************************************************************************
                          interface_update.cpp  -  description
                             -------------------
    begin                : Sat Jul 6 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "interface.h"


void Interface::interface_update_device() {

	int i;

 	static const char *banktypename[2] = {"Instr.","Drum"};

        updating_devices=true;
        
 	clist_device_banks->clear();
        clist_device_banks->freeze();

 	for (int i=0;i<dev_manager->get_bank_count();i++) {

		list<string> names;	
		names.push_back(itostr(i));
		names.push_back(dev_manager->get_bank(i)->get_model_name());
		names.push_back(banktypename[dev_manager->get_bank(i)->get_type()]);
		names.push_back(dev_manager->get_bank(i)->get_name());
	   	clist_device_banks->append(names);
  	}	

        clist_device_banks->thaw();


	//bank_tree.clear_items(0,bank_tree_crap.size()-1);
	bank_tree.tree().clear();
	for (int i=0;i<bank_tree_crap.size();i++) delete bank_tree_crap[i];
	bank_tree_crap.clear();
       
 	for (int i=0;i<dev_manager->get_bank_count();i++) {

  		int j=-1;
  		char numb[4];
    		string bankstring;
    		numb[3]=0;
      		numb[0]='0'+i/100;
      		numb[1]='0'+(i/10)%10;
      		numb[2]='0'+i%10;

        	bankstring=(string)numb+(string)"-"+dev_manager->get_bank(i)->get_model_name()+(string)"  "+dev_manager->get_bank(i)->get_name();       	
  
  		bank_tree_crap.push_back( new GtkSucksItem( bankstring ) );

	   	bank_tree.tree().push_back(bank_tree_crap[i]->ti);
		bank_tree_crap[i]->ti.select.connect(SigC::bind<int,int>(SigC::slot(this,&Interface::on_tree_item_select),i,j));
		//if (selected.bank==i) bank_tree_crap[i]->ti.select();
	              		
		for ( j=0;j<dev_manager->get_bank(i)->get_drums_count();j++) {

			if (j==0) {

				bank_tree_crap[i]->ti.set_subtree(bank_tree_crap[i]->drums_subtree);
			}
			numb[0]='0'+j/100;
			numb[1]='0'+(j/10)%10;
			numb[2]='0'+j%10;

			bankstring=(string)numb+(string)"-DRUMS "+dev_manager->get_bank(i)->get_drums(j)->get_name();

			bank_tree_crap[i]->drums.push_back(new GtkSucksItem::GtkSucksEvenMoreItem( bankstring ) );
			bank_tree_crap[i]->drums_subtree.tree().push_back(bank_tree_crap[i]->drums[j]->ti);
			bank_tree_crap[i]->drums[j]->ti.select.connect(SigC::bind<int,int>(SigC::slot(this,&Interface::on_tree_item_select),i,j));
			
		}    
//    		ti->show();
	/*	list<string> names;
		names.push_back(itostr(i));
		names.push_back(dev_manager->get_bank(i)->get_model_name());
		names.push_back(banktypename[dev_manager->get_bank(i)->get_type()]);
		names.push_back(dev_manager->get_bank(i)->get_name());*/
  	}

   	

    
	if (dev_manager->get_bank_count()) {


		frame4->show();
  		vbox3->show();
	} else {


		frame4->hide();
  		vbox3->hide();

 	}
//	spinbutton_bank_number->get_adjustment()->set_upper(dev_manager->get_bank_count()-1);

        updating_devices=false;
        	
        interface_update_bank();


}

void Interface::interface_update_bank() {

        if (selected.bank==-1) return;

	updating_bank=true;

 	entry_device_bank_engine->set_text(bank()->get_model_name());		
 	entry_device_bank_name->set_text(bank()->get_name());		

  	if (bank()->get_type()==Bank::INSTRUMENT) {

		radiobutton_device_bank_type_instrument->set_active(true);
   	} else {

		radiobutton_device_bank_type_drum->set_active(true);
    	}

  	clist_bank_patch->freeze();

	for (int i=0;i<128;i++) {

		clist_bank_patch->set_text(i,3,bank()->get_patch_name(i));
		if (bank()->get_type()==Bank::INSTRUMENT) {
		
			clist_bank_patch->set_text(i,2,"N/A");
		} else {

			clist_bank_patch->set_text(i,2,notes[bank()->get_drum_note(i)]);
		}
       	}

        if (bank()->get_type()==Bank::INSTRUMENT) {
        
                spinbutton_bank_number->hide();
                label21b->hide();
        } else {

                spinbutton_bank_number->show();
                label21b->show();
        }

   	clist_bank_patch->thaw();
        spinbutton_bank_number->set_value(bank()->get_drum_note(selected_patch));
 	updating_bank=false;

  	interface_update_patch();
}

void Interface::interface_update_patch() {

        updating_patch=true;
        entry_bank_patch_name->set_text(bank()->get_patch_name(selected_patch));
	entry_bank_type->set_text(bank()->get_model_name());
        dynamic_config.set_property_list(bank()->get_patch_properties(selected_patch));
        draw_voice_preview();
        updating_patch=false;

}



void Interface::update_info_widgets() {

        display_cache.counter++;


	if (!(display_cache.counter%spinbutton_config_gui_refresh_rate->get_value_as_int())) {

		if (display_cache.active_voices!=mixer->get_active_voices()) {

          		display_cache.active_voices=mixer->get_active_voices();
  			entry_info_voices->set_text(itostr(display_cache.active_voices));
     		}

		if (display_cache.event_count!=midi_event->get_event_count()) {

			display_cache.event_count=midi_event->get_event_count();
     			entry_info_events->set_text(itostr(display_cache.event_count));
     		}

       		for (int i=0;i<16;i++) {

                 	/*voice show*/
			if (mixer->is_channel_in_use(i)) {

   				voice_show[i].set_buffer(mixer->get_buf_ptr(i),1000);
       			} else {
   				voice_show[i].set_buffer(NULL,0);

                  	}

			/*stuff (names)*/
                 	string patchname;

                  	Bank * sbank=dev_manager->get_bank(midi_event->get_chan_bank(i));
                   	if (sbank==NULL) continue;

			patchname=itostr(midi_event->get_chan_patch(i)) +" - "+ sbank->get_patch_name(midi_event->get_chan_patch(i));

   			if (patchname!=display_cache.instrument[i]) {

				display_cache.instrument[i]=patchname;

    				entry_info_array[i]->set_text(patchname);
              		}


         	}

 	}

}

void Interface::interface_update_config() {

	updating_config=true;

	float p1,p2,p3,p4,p5,p6;
	float f1,f2,f3,f4,f5,f6;

	mixer->get_reverb_params(f1,f2,f3,f4,f5);
	mixer->get_chorus_params(p1,p2,p3,p4,p5);

	hscale6_adj->set_value(p1);
	hscale_config_chorus_speed_adj->set_value(p2);
	hscale_config_chorus_depth_adj->set_value(p3);
	hscale_config_chorus_feedback_adj->set_value(p4);
	hscale_config_chorus_width_adj->set_value(p5);


	hscale_config_reverb_room_adj->set_value(f1);
	hscale_config_reverb_damp_adj->set_value(f2);
	hscale_config_reverb_wet_adj->set_value(f3);
	hscale_config_reverb_dry_adj->set_value(f4);
	hscale_config_reverb_width_adj->set_value(f5);


	/* Clist of devices */

 	clist_config_audio_driver_list->clear();
        clist_config_audio_driver_list->freeze();
        printf("%i drivers..\n",driver_manager->get_amount_of_drivers());
 	for (int i=0;i<driver_manager->get_amount_of_drivers();i++) {

		list<string> names;
		names.push_back(driver_manager->get_driver_name(i));
	   	clist_config_audio_driver_list->append(names);
  	}

        clist_config_audio_driver_list->thaw();



	checkbutton_config_output_16bits->set_active(driver_manager->get_mix_16bits());
	checkbutton_config_output_stereo->set_active(driver_manager->get_mix_stereo());
//	checkbutton_config_output_16bits->set_active(driver_manager->get_mix_16bits());
        optionmenu_config_output_frequency->get_entry()->set_text(itostr(driver_manager->get_mix_frequency()));
        combo_config_buffersize->get_entry()->set_text(itostr(driver_manager->get_mix_buffer_size()));
        
        if (driver_manager->is_active_driver_active())
	        radiobutton_config_output_enabled->set_active(true);
	else
	        radiobutton_config_output_disabled->set_active(true);

	        
        clist_config_audio_driver_list->row(driver_manager->get_active_driver()).select();
	updating_config=false;

}

void Interface::draw_voice_preview() {

	Bank * sbank = bank();
	if (sbank==NULL) return;
	Voice * voice = sbank->get_voice(selected_patch);
	voice_preview.render_voice(voice,mixer->get_mix_frequency());
	delete voice;
}
