/***************************************************************************
                          interface_widget_dynamic_config.cpp  -  description
                             -------------------
    begin                : Sat Jul 6 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "interface_widget_dynamic_config.h"


Dynamic_Property_Base::Dynamic_Property_Base(Property *p_property) :  label(p_property->get_name()) {

        pack_start(label,false,false);
 	label.show();
  	label.set_usize(200,30);
  	show();
}

/***/

Dynamic_Property_Separator::Dynamic_Property_Separator(Separator_Property *p_property) : Dynamic_Property_Base(p_property) {

        pack_start(separator);
        separator.show();
}

/***/

Dynamic_Property_Value::Dynamic_Property_Value(Value_Property *p_property) : Dynamic_Property_Base(p_property), scale_adj(p_property->get_val(),p_property->get_min(),p_property->get_max(),1,5), scale(scale_adj) {

	scale_adj.value_changed.connect(SigC::slot(this,&Dynamic_Property_Value::change_val));
	scale.set_digits(0);
	pack_start(scale);
 	scale.show();

  	property=p_property;
   	
}

void Dynamic_Property_Value::change_val() {

	property->set_val((int)scale_adj.get_value());
	changed.emit();
}

/***/

void Dynamic_Property_Bool::change_val() {

	property->set_status(cbutton.get_active());	
	changed.emit();
}


Dynamic_Property_Bool::Dynamic_Property_Bool(Bool_Property *p_property) : Dynamic_Property_Base(p_property), cbutton("Ok!") {
        property=p_property;
	cbutton.set_active(property->get_status());
	cbutton.clicked.connect(SigC::slot(this,&Dynamic_Property_Bool::change_val));
 	cbutton.show();
  	pack_start(cbutton);
}

/****/

void Dynamic_Property_Choice::change_val() {

	property->set_selected(option_select.get_option_selected());
	changed.emit();
}


Dynamic_Property_Choice::Dynamic_Property_Choice(Multiple_Choice_Property *p_property) : Dynamic_Property_Base(p_property) {

        property=p_property;

	option_select.selected.connect(SigC::slot(this,&Dynamic_Property_Choice::change_val));
 	option_select.show();
  	for (int i=0;i<p_property->get_choice_count();i++) {

		option_select.add_option(p_property->get_choice(i));
   	}
	option_select.select_option(p_property->get_selected());    
  	pack_start(option_select);
}

/****/
/*
void Dynamic_Property_Image::change_val() {

	property->set_selected(scale_adj.get_value());
//        pixmap.set((const gchar* const *)property->get_choice(property->get_selected()));
	changed.emit();
}


//Dynamic_Property_Image::Dynamic_Property_Image(Image_Choice_Property *p_property) : Dynamic_Property_Base(p_property) ,  scale_adj(p_property->get_selected(),0,p_property->get_choice_count()-1,1,5), scale(scale_adj)  {
Dynamic_Property_Image::Dynamic_Property_Image(Image_Choice_Property *p_property) : Dynamic_Property_Base(p_property) ,  scale_adj(0,0,7,1,5), scale(scale_adj)  {


        property=p_property;

// 	pixmap.show();
  //      pixmap.set((const gchar* const *)p_property->get_choice(p_property->get_selected()));
  	scale.show();
	scale.set_digits(0);

//  	pack_start(vport,false,false);     	
  	pack_start(scale);
//   	vport.add(pixmap);
//    	vport.show();

} */
Dynamic_Property_Image::Dynamic_Property_Image(Image_Choice_Property *p_property) : Dynamic_Property_Base(p_property), scale_adj(p_property->get_selected(),0,p_property->get_choice_count()-1,1,5), scale(scale_adj) {

	scale_adj.value_changed.connect(SigC::slot(this,&Dynamic_Property_Image::change_val));
	scale.set_digits(0);
	vport.add(pixmap);
	pack_start(vport,false,false);
	pack_start(scale);
 	scale.show();
  	pixmap.show();
   	vport.show();
	pixmap.set((const gchar* const *)p_property->get_choice(p_property->get_selected()));

  	property=p_property;

}

void Dynamic_Property_Image::change_val() {

	//property->set_val((int)scale_adj.get_value());
	property->set_selected(scale_adj.get_value());
	pixmap.set((const gchar* const *)property->get_choice(property->get_selected()));
	changed.emit();
}

 /***/

void Interface_Widget_Dynamic_Config::add_widget(Dynamic_Property_Base* p_base) {
        if (!sections.size()) {

        	ERROR("Trying to add property outside a section!! this causes a memleak, so fix it. ;)");
         	return;
	}

	sections[sections.size()-1]->pack_start(*p_base,false,false);
}

void Interface_Widget_Dynamic_Config::set_property_list(PropertyList *p_proplist) {

	PropertyList::iterator I;
        clear();

        hide();
 	for (I=p_proplist->begin();I!=p_proplist->end();I++) {

		Property *pr =*I;
		Dynamic_Property_Base *newprop=NULL;

  		if (pr->get_type()=="separator") {

                	add_widget(new Dynamic_Property_Separator((Separator_Property*)pr));
            	
             	} else if (pr->get_type()=="value") {

                	add_widget(newprop=new Dynamic_Property_Value((Value_Property*)pr));

             	} else if (pr->get_type()=="bool") {

                	add_widget(newprop=new Dynamic_Property_Bool((Bool_Property*)pr));

             	} else if (pr->get_type()=="option") {

                	add_widget(newprop=new Dynamic_Property_Choice((Multiple_Choice_Property*)pr));

             	} else if (pr->get_type()=="image_option") {

                	add_widget(newprop=new Dynamic_Property_Image((Image_Choice_Property*)pr));

             	} else if (pr->get_type()=="section") {

			sections.resize(sections.size()+1);
   			sections[sections.size()-1]=new Section(pr->get_name());
      			pages().push_back(Gtk::Notebook_Helpers::TabElem(sections[sections.size()-1]->scrolledwindow,sections[sections.size()-1]->label));
      			
              	}

		if (newprop!=NULL) {

			newprop->changed.connect(SigC::slot(this,&Interface_Widget_Dynamic_Config::prop_changed));
		}
  	}
        show();

}

void Interface_Widget_Dynamic_Config::clear() {

	for (int i=0;i<sections.size();i++) {

		delete sections[i];
 	}

  	sections.clear();
 	pages().clear();
}


Interface_Widget_Dynamic_Config::Interface_Widget_Dynamic_Config() {

	set_flags(GTK_CAN_FOCUS);
	set_show_tabs(true);
	set_show_border(true);
	set_tab_pos(GTK_POS_TOP);
	set_scrollable(true);

	//pages().push_back(Gtk::Notebook_Helpers::TabElem(*vbox2, *label20));
	//pages().push_back(Gtk::Notebook_Helpers::TabElem(*frame8, *label21));

}

void Interface_Widget_Dynamic_Config::prop_changed() {


	changed.emit();
}

Interface_Widget_Dynamic_Config::~Interface_Widget_Dynamic_Config() {
}
