/***************************************************************************
                          interface_widget_dynamic_config.h  -  description
                             -------------------
    begin                : Sat Jul 6 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INTERFACE_WIDGET_DYNAMIC_CONFIG_H
#define INTERFACE_WIDGET_DYNAMIC_CONFIG_H

#include <gtk--/notebook.h>
#include <gtk--/box.h>
#include <gtk--/scale.h>
#include <gtk--/adjustment.h>
#include <gtk--/label.h>
#include <gtk--/separator.h>
#include <gtk--/scrolledwindow.h>
#include <gtk--/checkbutton.h>
#include <gtk--/pixmap.h>
#include <gtk--/spinbutton.h>
#include <gtk--/viewport.h>
#include <property.h>
#include "interface_widget_optionselect.h"
/**
  *@author red
  */

/* BASE */

class Dynamic_Property_Base : public Gtk::HBox{
protected:
	Dynamic_Property_Base() {};
        Gtk::Label label;



	Dynamic_Property_Base(Property *p_property);

public:

	SigC::Signal0<void> changed;	
};

/* IMPLEMENTATIONS */

class Dynamic_Property_Separator : public Dynamic_Property_Base {

        Gtk::HSeparator separator;
public:

	Dynamic_Property_Separator(Separator_Property *p_property);
};

class Dynamic_Property_Value : public Dynamic_Property_Base {

        Value_Property *property;
	void change_val();
        Gtk::Adjustment scale_adj;
        Gtk::HScale scale;
public:
	Dynamic_Property_Value(Value_Property *p_property);
};


class Dynamic_Property_Bool : public Dynamic_Property_Base {

        Bool_Property *property;
	void change_val();
        Gtk::CheckButton cbutton;
public:
	Dynamic_Property_Bool(Bool_Property *p_property);
};

class Dynamic_Property_Choice : public Dynamic_Property_Base {

        Multiple_Choice_Property *property;
	void change_val();
	Interface_Widget_OptionSelect option_select;
public:
	Dynamic_Property_Choice(Multiple_Choice_Property *p_property);
};
/*
class Dynamic_Property_Image : public Dynamic_Property_Base {

        Image_Choice_Property *property;
	void change_val();
	Gtk::HScale scale;
	Gtk::Adjustment scale_adj;
	Gtk::Viewport vport;
	Gtk::Pixmap pixmap;
public:
	Dynamic_Property_Image(Image_Choice_Property *p_property);
};
  */
class Dynamic_Property_Image : public Dynamic_Property_Base {

        Image_Choice_Property *property;
	void change_val();
        Gtk::Adjustment scale_adj;
        Gtk::HScale scale;
	Gtk::Viewport vport;
	Gtk::Pixmap pixmap;
        
public:
	Dynamic_Property_Image(Image_Choice_Property *p_property);
};


class Interface_Widget_Dynamic_Config : public Gtk::Notebook {

	struct Section : public Gtk::VBox {

          	vector<Dynamic_Property_Base*> propwidget_list;
         	Gtk::Label label;
          	Gtk::ScrolledWindow scrolledwindow;

           	
		Section(string p_name) : label(p_name) {

          		show();
            		label.show();
              		scrolledwindow.set_policy(GTK_POLICY_ALWAYS, GTK_POLICY_ALWAYS);
			scrolledwindow.add_with_viewport(*this);
   			scrolledwindow.show();

  		}

  		~Section() {

            		for (int i;i<propwidget_list.size();i++) delete propwidget_list[i];
            	}

 	};

  	vector<Section*> sections;
	
 	void add_widget(Dynamic_Property_Base* p_base);

  	void prop_changed();

public:

	SigC::Signal0<void> changed;

	void set_property_list(PropertyList *p_proplist);
	void clear();
 	
	Interface_Widget_Dynamic_Config();
	~Interface_Widget_Dynamic_Config();
};

#endif
