/***************************************************************************
                          interface_widget_voice_preview.cpp  -  description
                             -------------------
    begin                : Thu Jul 18 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "interface_widget_voice_preview.h"



void Interface_Widget_Voice_Preview::set_zoom(int p_zoom) {

	zoom=p_zoom;
	queue_draw();

}


void Interface_Widget_Voice_Preview::render_voice(Voice *p_voice, int p_mixfreq) {


	if (p_mixfreq==0) p_mixfreq=44100;


	if (data.size()!=(p_mixfreq*2)) {

		data.resize(p_mixfreq*2);
	}
			
	queue_draw();
	voice=p_voice;

	if (voice!=NULL) {

	
		voice->set_mix_frequency(p_mixfreq);
		voice->set_pan(64);
		voice->set_expression(127);
		voice->set_main_volume(127);
		voice->set_note(69-12,127);
		memset(&data[0],0,data.size()*sizeof(Sint32));
		voice->mix(p_mixfreq,&data[0]);
	}	
}


void Interface_Widget_Voice_Preview::realize_callback() {

        fg.red=0x2000;
        fg.green=0xAFFF;
        fg.blue=0xFFFF;
        bg.red=0x0;
        bg.green=0x0;
        bg.blue=0x0;
        sep.red=0x8000;
	sep.green=0x8000;
 	sep.blue=0x8000;

	get_colormap().alloc(fg);
	get_colormap().alloc(bg);
	get_colormap().alloc(sep);

        bgcol.create(get_window());
        sepcol.create(get_window());
        fgcol.create(get_window());

        bgcol.set_foreground(bg);
        fgcol.set_foreground(fg);
        sepcol.set_foreground(sep);
        bgcol.set_exposures(1);

        get_window().set_background(bg);
        

}


gint Interface_Widget_Voice_Preview::expose_event_impl(GdkEventExpose *event) {

	double w=width();
	double h=height()/2;
 	double max=0x1FFFFFFF/2;
	int index;
 	double val;

 	get_window().draw_rectangle(bgcol,true,1,1,width()-1,height()-1);
 	get_window().draw_rectangle(sepcol,false,0,0,width(),height());

	if (voice==NULL) return 0;

	for(int i=0;i<w;i++) {

		index=i*(data.size()/2)/w;
		index=index*zoom/100;
		val=data[index*2];
  		val=val*h/max;
    		get_window().draw_point(fgcol,i,h+val);
	}

 	return 0;
}


Interface_Widget_Voice_Preview::Interface_Widget_Voice_Preview(){

        realize.connect(SigC::slot(this,&Interface_Widget_Voice_Preview::realize_callback));
        show();
        voice=NULL;
        zoom=100;

}
Interface_Widget_Voice_Preview::~Interface_Widget_Voice_Preview(){
}
