/***************************************************************************
                          interface_widget_voice_show.cpp  -  description
                             -------------------
    begin                : Sat Jul 6 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "interface_widget_voice_show.h"


void Interface_Widget_Voice_Show::set_buffer(Sint32 *p_buffer,int p_size) {

	if (buffer!=NULL) queue_draw();
	buffer=p_buffer;
 	size=p_size;

}


void Interface_Widget_Voice_Show::realize_callback() {

        fg.red=0x2000;
        fg.green=0xAFFF;
        fg.blue=0xFFFF;
        bg.red=0x0;
        bg.green=0x0;
        bg.blue=0x0;
        sep.red=0x8000;
	sep.green=0x8000;
 	sep.blue=0x8000;

	get_colormap().alloc(fg);
	get_colormap().alloc(bg);
	get_colormap().alloc(sep);

        bgcol.create(get_window());
        sepcol.create(get_window());
        fgcol.create(get_window());

        bgcol.set_foreground(bg);
        fgcol.set_foreground(fg);
        sepcol.set_foreground(sep);
        bgcol.set_exposures(1);

        get_window().set_background(bg);
	
}


gint Interface_Widget_Voice_Show::expose_event_impl(GdkEventExpose *event) {

	double w=width();
	double h=height()/2;
 	double max=0x1FFFFFFF/2;
	int index;										
 	double val;

 	get_window().draw_rectangle(bgcol,true,1,1,width()-1,height()-1);
 	get_window().draw_rectangle(sepcol,false,0,0,width(),height());

	if (buffer==NULL) return 0;

	for(int i=0;i<w;i++) {

		index=i*size/w;
		val=buffer[index];
  		val=val*h/max;
    		get_window().draw_point(fgcol,i,h+val);	
	}

 	return 0;
}


Interface_Widget_Voice_Show::Interface_Widget_Voice_Show(){

        realize.connect(SigC::slot(this,&Interface_Widget_Voice_Show::realize_callback));
	buffer=NULL;

}
Interface_Widget_Voice_Show::~Interface_Widget_Voice_Show(){
}
