/*===========================================================================
                          popups.cpp  -  description
                             -------------------
    begin                : Sun May 26 2002
    copyright            : (C) 2002 by CODENIX
    email                : info@codenix.com.ar
============================================================================*/


#include "popups.h"
#ifdef WIN32_ENABLED
#include <windows.h>
#endif

/* OK / CANCEL THING */
/*************************
	DIALOG OK - CANCEL
	**************************/


void Dialog_OkCancel::button_ok_pressed() {

	action=OK;
}

void Dialog_OkCancel::button_cancel_pressed() {

	action=CANCEL;
}

Dialog_OkCancel::Dialog_OkCancel(string p_label_text,Gtk::Main &p_kit) : button("OK"), button2("Cancel") {

	set_position(GTK_WIN_POS_CENTER);
	set_modal(true);
	label = new Gtk::Label(p_label_text);
	get_action_area()->pack_start(button, FALSE, FALSE, 3);
	get_action_area()->pack_start(button2, FALSE, FALSE, 3);

	get_vbox()->pack_start (*label, TRUE, TRUE, 0);
	label->set_padding(20,20);
	button.show();
	button.clicked.connect(slot(this,&Dialog_OkCancel::button_ok_pressed));	
	button2.show();
	button2.clicked.connect(slot(this,&Dialog_OkCancel::button_cancel_pressed));	

	label->show();
	set_policy(false, false, false);
	set_title("-=_/-([?])-\\_=-");
	show();
	button.grab_focus();

	action=WAITING;

	do {

		while (p_kit.events_pending()) p_kit.iteration();
		usleep(1);

	} while (action==WAITING);

}
Dialog_OkCancel::~Dialog_OkCancel() {

 	delete label;
}


/*************************
	FILE ACCESS_WIDGET
	***************************/

	
void File_Access_Widget::set_mode(int p_mode) {

	if (p_mode==SAVE) {

		set_title("Save file..");
		current_mode=SAVE;

	} else if (p_mode==LOAD) {

		set_title("Load file..");
		current_mode=LOAD;

	}
}

void File_Access_Widget::button_ok_pressed() {
	
	string tmp_filename;
	
        tmp_filename=get_filename();

	if (tmp_filename[tmp_filename.length()-1]=='/') {

		/* might as well change directory */

		return;
	}
	
	if (current_mode==LOAD) {

		action=OK;

	} else {

                FILE *t_f;
                Dialog_OkCancel *confirm_overwrite;
		t_f=fopen(tmp_filename.c_str(),"r");
		if (t_f!=NULL) {

			confirm_overwrite=new Dialog_OkCancel("File exists! overwrite?",*kit);
			if (confirm_overwrite->get_action()==Dialog_OkCancel::OK) action=OK;
			delete confirm_overwrite;
			fclose(t_f);
		} else {
		
                	action=OK;
		}
	}
}

/*
list<string> File_Access_Widget::get_list_of_filenames() {
	
       	list<string> nothing;

        return nothing;
}
*/
void File_Access_Widget::add_filter_rule(FilterRule &filter_rule) {


}


void File_Access_Widget::button_cancel_pressed() {


	action=CANCEL;

}

void File_Access_Widget::poll_until_action(Gtk::Main &p_kit) {

        action=WAITING;
        kit=&p_kit;
	do {

		while (kit->events_pending()) kit->iteration();
		usleep(1);

	} while (action==WAITING);

}

File_Access_Widget::File_Access_Widget() {

        get_ok_button()->clicked.connect(slot(this,&File_Access_Widget::button_ok_pressed));
        get_cancel_button()->clicked.connect(slot(this,&File_Access_Widget::button_cancel_pressed));
	set_position(GTK_WIN_POS_CENTER);
	set_modal(true);

	show();
	action=WAITING;
}

File_Access_Widget::~File_Access_Widget() {


}
