/***************************************************************************
                          bank.h  -  description
                             -------------------
    begin                : Fri Jul 5 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BANK_H
#define BANK_H

#include "typedefs.h"
#include "property.h"
#include "voice.h"

/**
  *@author red
  */

class Bank {
public:
        static const int version;
	enum Type {

         	INSTRUMENT,
          	DRUM
 	};

protected:
        string name;
        Type type;

        vector<char> drum_note;
       	vector<Bank*> drums;
       	vector<Voice::Default_Data> patch_defaults;
	vector<PropertyList> patch_prop;

	                
 	virtual Bank * get_drums_bank()=0;
 	virtual string get_model_name_base()=0;
 	virtual Voice * get_voice_internal(int p_patch) =0;

  	int get_patch_default_controller_internal(int p_patch,int p_ctrl);

public:

		
	int get_patch_default_controller(int p_patch,int p_ctrl);


	Type set_type(Type p_type) { type=p_type; };
	Type get_type() { return type; };

	void set_drum_note(char p_patch,char p_note) { drum_note[p_patch]=p_note;}
	char get_drum_note(char p_patch) { return drum_note[p_patch]; }

	
	string get_model_name() { return get_model_name_base()+( (type==DRUM)?"-DRUM":"" ); };
	void set_name(string p_name) { name=p_name; };
	string get_name() { return name; };
	virtual PropertyList * get_patch_properties(int p_patch) =0;
	Voice * get_voice(int p_patch);

 	virtual string get_patch_name(int p_index)=0;
 	virtual void set_patch_name(int p_index,string p_name)=0;
	virtual bool load_file(string p_file, int p_offset=0);
	virtual bool load_patch(string p_file, int p_index=0);

 	void get_patch_data_vector(int p_patch, vector<Uint8> &p_vector);
 	bool set_patch_data_vector(int p_patch, Uint8* p_vector,int p_size);

 	void get_bank_data_vector(vector<Uint8> &p_vector);
 	bool set_bank_data_vector(Uint8* p_vector,int p_size);

	int get_drums_count() { return drums.size(); }  	
	Bank *get_drums(int p_index);
	void add_drums();
	void delete_drums(int p_index);
  
	Bank();
	virtual ~Bank();
};


#endif
