/***************************************************************************
                          device_manager.cpp  -  description
                             -------------------
    begin                : Sat Jul 6 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "device_manager.h"


void Device_Manager::add_device(Device *p_device) {

	device_list.push_back(p_device);
}
Device * Device_Manager::get_device(int p_index) {

	if (p_index<0) return NULL;
	if (p_index>=device_list.size()) return NULL;

 	return device_list[p_index];
}

void Device_Manager::add_bank(int p_using_device_index) {

	if (p_using_device_index<0) return;
	if (p_using_device_index>=device_list.size()) return;

	bank_list.push_back(device_list[p_using_device_index]->create_bank());
 	

}
Bank *Device_Manager::get_bank(int p_index) {

	if (p_index<0) return NULL;
	if (p_index>=bank_list.size()) return NULL;

	return bank_list[p_index];
}

int Device_Manager::get_device_count() {

	return device_list.size();

}

int Device_Manager::get_bank_count() {

	return bank_list.size();
}

void Device_Manager::copy_patch(int p_bank,int p_drum,int p_patch) {

	if (p_bank<0) return ;
	if (p_bank>=bank_list.size()) return ;

 	patch_clipboard.clear();
  	if (p_drum!=-1) {

		if (get_bank(p_bank)->get_drums(p_drum)==NULL) return;
		get_bank(p_bank)->get_drums(p_drum)->get_patch_data_vector(p_patch,patch_clipboard);
		
   	} else {
    
		get_bank(p_bank)->get_patch_data_vector(p_patch,patch_clipboard);
	}
}

void Device_Manager::paste_patch(int p_bank,int p_drum,int p_patch) {

	if (patch_clipboard.size()==0) return;        		
	if (p_bank<0) return ;
	if (p_bank>=bank_list.size()) return ;
 	int size=get_int_from_vector(&patch_clipboard[0]);

  	if (p_drum!=-1) {

		if (get_bank(p_bank)->get_drums(p_drum)==NULL) return;
		get_bank(p_bank)->get_drums(p_drum)->set_patch_data_vector(p_patch,&patch_clipboard[4],size);

   	} else {
  
		get_bank(p_bank)->set_patch_data_vector(p_patch,&patch_clipboard[4],size);
	}

}


void Device_Manager::copy_bank(int p_bank) {
	if (p_bank<0) return ;
	if (p_bank>=bank_list.size()) return ;

 	bank_clipboard.clear();
	get_bank(p_bank)->get_bank_data_vector(bank_clipboard);

}
void Device_Manager::paste_bank(int p_bank) {
	if (p_bank<0) return ;
	if (p_bank>=bank_list.size()) return ;
	if (bank_clipboard.size()==0) return;
        Bank * new_bank;

        for (int i=0;i<device_list.size();i++) { //this sucks ;) but i'm hurried so i dont care.

		int size=get_int_from_vector(&bank_clipboard[0]);
        	new_bank=device_list[i]->create_bank();

		
		if (!new_bank->set_bank_data_vector(&bank_clipboard[4],size)) {

			bank_list.push_back(new_bank);
   			return;          		
          	}
         	delete new_bank;
	}
}
void Device_Manager::load_bank(string p_filename) {

        Bank * new_bank;
	vector<Uint8> bankdata;          		
        int size;
        if (load_vector_from_file(p_filename,bankdata)) {

        	ERROR("error loading file: " << p_filename);
        	return;
        }

	size=get_int_from_vector(&bankdata[0]);

        for (int i=0;i<device_list.size();i++) { //this sucks ;) but i'm hurried so i dont care.

        	new_bank=device_list[i]->create_bank();
 		
		if (!new_bank->set_bank_data_vector(&bankdata[4],size)) {

			bank_list.push_back(new_bank);
   			return;          		
          	}
         	delete new_bank;
	}
}

void Device_Manager::bank_moveup(int p_index) {

	if (p_index==0) return;
	Bank *aux;
 	aux=bank_list[p_index-1];
 	bank_list[p_index-1]=bank_list[p_index];
  	bank_list[p_index]=aux;


}

void Device_Manager::bank_delete(int p_bank) {

	if (p_bank<0) return ;
	if (p_bank>=bank_list.size()) return ;

        delete bank_list[p_bank];
        bank_list.erase(bank_list.begin()+p_bank);
}

void Device_Manager::bank_movedown(int p_index) {

	if (p_index==(bank_list.size()-1)) return;
	Bank *aux;
 	aux=bank_list[p_index+1];
 	bank_list[p_index+1]=bank_list[p_index];
  	bank_list[p_index]=aux;
}


Device_Manager::Device_Manager(){
}
Device_Manager::~Device_Manager(){
}
