/***************************************************************************
                          device_manager.h  -  description
                             -------------------
    begin                : Sat Jul 6 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DEVICE_MANAGER_H
#define DEVICE_MANAGER_H

#include "device.h"
/**
  *@author red
  */


class Device_Manager {

	vector<Device*> device_list;	
	vector<Bank*> bank_list;

        vector<Uint8> patch_clipboard;
        vector<Uint8> bank_clipboard;


 	
public:
	void add_device(Device *p_device);
 	Device * get_device(int p_index);
  	int get_device_count();

  	void add_bank(int p_using_device_index);
  	Bank *get_bank(int p_bank_index);
  	int get_bank_count();

   	void copy_patch(int p_bank,int p_drum,int p_patch);
   	void paste_patch(int p_bank,int p_drum,int p_patch);
   	void copy_bank(int p_bank);
   	void paste_bank(int p_bank);

    	void bank_moveup(int p_index);
    	void bank_movedown(int p_index);

    	void bank_delete(int p_bank);

        void load_bank(string p_filename);
	Device_Manager();
	~Device_Manager();
};

#endif
