/***************************************************************************
                          mixer_effects.cpp  -  description
                             -------------------
    begin                : Sat Jul 13 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "mixer.h"

#include <math.h>
#define REVERB_SOFT_BITS 11



/********************************R*E*V*E*R*B****************************/


void Mixer::process_reverb(int p_amount) {

	
	float soften = 0.65;
	float *rev_l,*rev_r;
	int samples_todo;
	Sint32 *buff_write;


	samples_todo=p_amount;
	rev_l=&reverb_in_l[0];
	rev_r=&reverb_in_r[0];
	buff_write=&reverb_buffer[0];

	//copy to mix buffer!
	while (samples_todo--) { //this can be easily optimized doing the int->float conversion by hand, but i wont touch it unless it's really needed

	        //this is a quick hack to avoid losing precision while freeverb manages the floats
		*rev_l++ = ((float)(*(buff_write++) >> REVERB_SOFT_BITS) * soften);
		*rev_r++ = ((float)(*(buff_write++) >> REVERB_SOFT_BITS) * soften);
	}

	//mmmmmmmix reverb!
	freeverb.processreplace(&reverb_in_l[0], &reverb_in_r[0],&reverb_out_l[0],&reverb_out_r[0],p_amount,1);

	samples_todo=p_amount;
	rev_l=&reverb_out_l[0];
	rev_r=&reverb_out_r[0];
	buff_write=&mix_buffer[0];

	//mix BACK to main BUFFER!
	while (samples_todo--) {

		*buff_write++ +=  (int)(*(rev_l++)) << REVERB_SOFT_BITS;
		*buff_write++ +=  (int)(*(rev_r++)) << REVERB_SOFT_BITS;
	}


}

/**********************C*H*O*R*U*S***********************/


void Mixer::process_chorus(int p_amount) {
//	if (!chorus_enabled) return;

	chorus.set_mixfreq(mix_freq);
	chorus.process(&mix_buffer[0],&chorus_buffer[0],p_amount);
}


//declicker, not really an effect, but works!

void Mixer::process_declicker() {

	Sint32 l,r;
        int index=0;
	while(index<declicker_list.size()) {

		l=declicker_list[index];
		r=declicker_list[index+1];

		if (l>DECLICKER_THRESHOLD) {

			for (int i=(DECLICKER_BUFFER_SIZE-1);i>=0;i--) {

				mix_buffer[(DECLICKER_BUFFER_SIZE-i)*2]+=i*l/DECLICKER_BUFFER_SIZE;

			}
		}
		if (r>DECLICKER_THRESHOLD) {

			for (int i=(DECLICKER_BUFFER_SIZE-1);i>=0;i--) {

				mix_buffer[(DECLICKER_BUFFER_SIZE-i)*2+1]+=i*r/DECLICKER_BUFFER_SIZE;

			}
		}
		index+=2;
	}
	declicker_list.clear();	
}
