/***************************************************************************
                          property.cpp  -  description
                             -------------------
    begin                : Fri Jul 5 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "property.h"



void append_int_to_vector(int p_val,vector<Uint8> &p_data) {

  	Uint32* valref;
     	(int*)valref=&p_val;
  	p_data.push_back(*valref&0xFF);      			
     	*valref>>=8;
  	p_data.push_back(*valref&0xFF);      			
     	*valref>>=8;
  	p_data.push_back(*valref&0xFF);      			
     	*valref>>=8;
  	p_data.push_back(*valref&0xFF);	
}

void append_string_to_vector(string p_string,vector<Uint8> &p_data) {

    	for (int i=0;i<p_string.length();i++) {
             	p_data.push_back((Uint8)p_string[i]);	

      	}						
	p_data.push_back(0);			
}


void append_vector_to_vector(vector<Uint8> &p_dest,vector<Uint8> &p_src) {

	p_dest.resize(p_dest.size()+p_src.size());
	memcpy(&p_dest[p_dest.size()-p_src.size()],&p_src[0],p_src.size());

}

unsigned get_int_from_vector(Uint8 *p_vector) {

	unsigned newint=0;
 	p_vector+=3;
 	newint|=*p_vector;
  	p_vector--;
  	newint<<=8;
 	newint|=*p_vector;
  	p_vector--;
  	newint<<=8;
 	newint|=*p_vector;
  	p_vector--;
  	newint<<=8;
 	newint|=*p_vector;

  	return newint;
}

unsigned get_string_from_vector(string &p_string,Uint8 *p_vector) {


        p_string=(char*)p_vector;
        return p_string.size()+1;
}



void PropertyList::append_data_to_vector(vector<Uint8> &p_data) {

	for (iterator I=begin();I!=end();I++) {

         	vector<Uint8> prop;
	
		//save type         	
		//save name
  		append_string_to_vector((*I)->get_type(),prop);
  		append_string_to_vector((*I)->get_name(),prop);

     		//now depending on each
		if ((*I)->get_type()=="separator") {
			//nothing
		} else if ((*I)->get_type()=="section") {
          		//nothing either!
            	} else if ((*I)->get_type()=="value") {
			append_int_to_vector(((Value_Property*)(*I))->get_val(),prop);
			
   		} else if ((*I)->get_type()=="option") {

			append_int_to_vector(((Multiple_Choice_Property*)(*I))->get_selected(),prop);
   		} else if ((*I)->get_type()=="image_option") {

			append_int_to_vector(((Image_Choice_Property*)(*I))->get_selected(),prop);
   		} else if ((*I)->get_type()=="bool") {

			append_int_to_vector(((Bool_Property*)(*I))->get_status(),prop);
   		} else {

             		continue;
             	}

		append_int_to_vector(prop.size(),p_data);

           	append_vector_to_vector(p_data,prop);    		
	}

}

static bool is_compatible(string p_format,string p_with_format) {

	if (p_format==p_with_format) return true;

	if (p_format=="image_option") {

		if (p_with_format=="value") return true;		
	}

	return false;

}

void PropertyList::read_data_from_array(Uint8 *p_data,int p_data_size) {

	int ofs=0;
 	Uint8 *orig=p_data;

	iterator I=begin();

	while (ofs<p_data_size) {

         	Uint8 *next;        	
 		string type;
   		string name;
     		int local_ofs=0;
     		
		if (I==end()) return; //nothing left!

     		next=p_data;
                local_ofs=get_int_from_vector(p_data);
                local_ofs+=4;

       		next+=local_ofs;
         	ofs+=local_ofs;

         	p_data+=4;
                p_data+=get_string_from_vector(type,p_data);
                p_data+=get_string_from_vector(name,p_data);

          	while (! ( is_compatible((*I)->get_type(),type) && ((*I)->get_name()==name) ) ) {

           		//Doesnt match! try next?
           		I++;
             		if (I==end()) return; //bleh
               	}

             	if ((*I)->get_type()=="value") {

               		((Value_Property*)(*I))->set_val(get_int_from_vector(p_data));
    		} else if ((*I)->get_type()=="option") {

 			((Multiple_Choice_Property*)(*I))->set_selected(get_int_from_vector(p_data));
    		} else if ((*I)->get_type()=="image_option") {
      
 			((Image_Choice_Property*)(*I))->set_selected(get_int_from_vector(p_data));
    		} else if ((*I)->get_type()=="bool") {

 			((Bool_Property*)(*I))->set_status(get_int_from_vector(p_data));
     		}

          	I++;         	

                p_data=next;
 	}       	
	
}




bool load_vector_from_file(string p_filename,vector<Uint8> &p_data) {

	FILE *f;
 	f=fopen(p_filename.c_str(),"rb");
  	if (f==NULL) return true;
   	int size;

    	fseek(f,0,SEEK_END);
     	size=ftell(f);
    	fseek(f,0,SEEK_SET);
      	
	p_data.resize(size);

   	fread(&p_data[0],1,p_data.size(),f);
        fclose(f);
        return false;

}
bool save_vector_to_file(string p_filename,vector<Uint8> &p_data) {

	FILE *f;
 	f=fopen(p_filename.c_str(),"wb+");
  	if (f==NULL) return true;
   	fwrite(&p_data[0],1,p_data.size(),f);
        fclose(f);

        return false;
}





Property::Property(){
}
Property::~Property(){
}
