/***************************************************************************
                          alsa_client.h  -  description
                             -------------------
    begin                : Mon Feb 4 2002
    copyright            : (C) 2002 by Juan Linietsky
    email                : coding@reduz.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef ALSA_ENABLED

#ifndef ALSA_CLIENT_H
#define ALSA_CLIENT_H

#include <alsa/asoundlib.h>
#include "midi_event.h"
#include "midi_event.h"
#include "midi_client.h"
/**
  *@author Juan Linietsky
  */

class Alsa_Client : public Midi_Client {

public:

	Midi_Event *midi_event;
private:
	snd_seq_t *handle;	/* The snd_seq handle to /dev/snd/seq */
	int client;		/* The client associated with this context */
	int port_index;	/* created sequencer ports */
	int fd;			/* The file descriptor */
	int used;		/* number of current connection */
	bool active;		/* */


	int get_file_descriptor();
	
	
public:

	void create_port();
	void dispatch_events();	
	

	Alsa_Client();
	~Alsa_Client();
};

#endif
#endif